2005-03-12  Jp Calderone  <exarkun@twistedmatrix.com>

	* twisted/scripts/mktap.py, twisted/scripts/twistd.py,
	twisted/application/app.py: Changed UID and GID defaults for Process
	to None.  Changed mktap behavior to not specify UID and GID if they
	are not given on the command line.  Changed application startup to
	not change UID or GID if they are not given.  Changed twistd to add
	UID and GID setting command line arguments.

2005-02-10  Jp Calderone  <exarkun@twistedmatrix.com>

	* twisted/internet/defer.py: DeferredLock, DeferredSemaphore, and
	DeferredQueue added.

	* twisted/test/test_defer.py: Tests for above mentioned three new
	classes.

2004-11-27  Brian Warner  <warner@lothar.com>

	* util.py (SignalStateManager.save): don't save signal handlers
	for SIGKILL and SIGSTOP, since we can't set them anyway.
	Python2.4c1 raises an error when you try.

2004-11-07  Brian Warner  <warner@lothar.com>

	* twisted/test/test_internet.py: correctly check for SSL support.
	Improve timeout for testCallLater and testGetDelayedCalls to avoid
	spurious failures on slow test systems. Close sockets in
	PortStringification to fix trial warnings.

	* twisted/internet/ssl.py: add a comment describing the correct
	way to import twisted.internet.ssl (since it might partially fail
	if OpenSSL is not available)

2004-11-06  Jp Calderone  <exarkun@twistedmatrix.com>

	* twisted/trial/assertions.py: assertRaises/failUnlessRaises now 
	returns the caught exception to allow tests to inspect the contents.

2004-11-02  Brian Warner  <warner@lothar.com>

	* loopback.py (loopbackTCP): use trial's spinWhile and spinUntil
	primitives instead of doing reactor.iterate() ourselves. Make sure
	to wait for everything before finishing.

2004-10-26  Cory Dodt <corydodt@twistedmatrix.com>

	* twisted/python/{which,process}.py,
	  twisted/test/{test_wprocess,wprocess_for_testing}.py,
	  twisted/internet/{default,error,wprocess,process}.py:  back out
	  wprocess due to test failures in wprocess and new trial.  Resolves 
	  issue 760.

2004-10-24  Itamar Shtull-Trauring  <itamar@itamarst.org>

	* TCP: Half-close of write and read for TCP connections, including
	protocol notification for protocols that implement
	IHalfCloseableProtocol.

2004-10-07  Jp Calderone  <exarkun@twistedmatrix.com>

	* Transports: Add a maximum to the number of bytes that will be
	held in the write buffer even after they have been sent.  This
	puts a maximum on the cost of writing faster than the network
	can accommodate.

2004-10-06  Itamar Shtull-Trauring  <itamar@itamarst.org>

	* Transports: New TCP/SSL/etc. buffering algorithm. All writes are
	now stored until next iteration before being written, and many
	small writes are not expensive.

2004-09-30  Brian Warner  <warner@lothar.com>

	* glib2reactor.py: new reactor that uses just glib2, not gtk2.
	This one doesn't require a DISPLAY, and cannot be used for GUI
	apps.

	* gtk2reactor.py: import gobject *after* pygtk.require, to make
	sure we get the same versions of both

2004-09-18  Christopher Armstrong  <radix@twistedmatrix.com>

	* twisted/internet/defer.py: Add deferredGenerator and
	waitForDeferred. This lets you write kinda-sorta
	synchronous-looking code that uses Deferreds. See the
	waitForDeferred docstring.

2004-09-11  Cory Dodt  <corydodt@twistedmatrix.com>

	* twisted/python/{which,process}.py,
	  twisted/test/{test_wprocess,wprocess_for_testing}.py,
	  twisted/internet/{default,error,wprocess,process}.py: merge the
	  "wprocess" branch which uses Trent Mick's process.py to enable
	  spawnProcess in the default reactor on Windows

2004-08-24  Brian Warner  <warner@lothar.com>

	* twisted/application/internet.py (TimerService): make it possible
	to restart a stopped TimerService. Threw out a lot of (apparently)
	unnecessary code in the process. Make sure it gets pickled in a
	not-running state too.
	* twisted/test/test_application.py (TestInternet2.testTimer): test
	the changes, and update the way the test peeks inside TimerService 

2004-07-18  Paul Swartz <z3p@twistedmatrix.com>

	* twisted/internet/utils.py: By passing errortoo=1, you can get 
	stderr from getProcessOutput

2004-07-18  Paul Swartz <z3p@twistedmatrix.com>

	* twisted/conch/unix.py: if the utmp module is available, record
	user logins/logouts into utmp/wtmp.

2004-06-25  Paul Swartz  <z3p@twistedmatrix.com>
	* twisted/conch/checkers.py: Use functionality of crypt module instead
	of an external module.

2004-06-25  Jp Calderone  <exarkun@twistedmatrix.com>

	* twisted/spread/banana.py: Disabled automatic import and use of
	cBanana.  PB will now use the pure-Python version of banana unless
	cBanana is manually installed by the application.

2004-06-12  Paul Swartz  <z3p@twistedmatrix.com>

	* twisted/conch/client: added -r flag to reconnect to the server if
	the connection is lost (closes 623).

2004-06-06  Dave Peticolas  <dave@krondo.com>

	* twisted/test/test_enterprise.py: test open callback and
	connect/disconnect.

	* twisted/enterprise/adbapi.py: add open callback support
	and disconnect() method. Issue 480.

2004-06-05  Dave Peticolas  <dave@krondo.com>

	* twisted/enterprise/adbapi.py: Don't log sql exceptions (issue 631).
	Remove deprecated api.

	* twisted/news/database.py: do not use adbapi.Augmentation

2004-06-03  Itamar Shtull-Trauring  <itamar@itamarst.org>

	* twisted/internet/gtk2reactor.py: The choice between glib event
	loop and gtk+ event loop is determined by argument at reactor
	install time.

2004-05-31  Dave Peticolas  <dave@krondo.com>

	* twisted/enterprise/sqlreflector.py: don't use Augmentation

	* twisted/enterprise/populate.sql: remove

	* twisted/enterprise/schema.sql: remove

	* twisted/enterprise/row.py: remove deprecated classes

	* twisted/enterprise/dbgadgets.py: remove

	* twisted/enterprise/dbcred.py: remove

	* twisted/test/test_enterprise.py: Fix Firebird test case.

2004-05-21  Itamar Shtull-Trauring  <itamar@itamarst.org>

	* twisted/internet/gtk2reactor.py: use glib event loop directly
	instead of gtk2's event loop if possible.

2004-05-04  Jp Calderone  <exarkun@twistedmatrix.com>

	* twisted.news, twisted.protocols.nntp: Moved back into trunk
	pending an alternate split-up strategy.

2004-05-04  Itamar Shtull-Trauring  <itamar@itamarst.org>

	* twisted.internet.reactor.listenUDP: transport.write() on UDP
	ports no longer supports unresolved hostnames (though deprecated
	support still exists).

2004-4-18  Christopher Armstrong  <radix@twistedmatrix.com>

	* twisted/lore/nevowlore.py, twisted/plugins.tml: Added Nevow
	support for lore. See docstring of twisted.lore.nevowlore.
	
2004-4-18  Christopher Armstrong  <radix@twistedmatrix.com>

	* twisted.news, twisted.protocols.nntp: Moved into a third party
	package. Deprecated backwards-compatibility exists by importing
	from the third-party package if available.

2004-4-11  Paul Swartz <z3p@twistedmatrix.com>

	* twisted.conch: refactored the Conch client to separate connecting
	to a server from user authentication from client-specific actions.

2004-03-23  Andrew Bennetts <spiv@twistedmatrix.com>

	* twisted.protocols.http: Small optimisation to HTTP implementation.
	This changes return value of toChunk to a tuple of strings, rather
	than one string.

2004-4-3  Paul Swartz <z3p@twistedmatrix.com>

	* twisted.python.lockfile: added lockfile support, based on
	liblockfile.
	* twisted.internet.unix.Port: added a wantPID kwarg.  If True, it
	checks for and gets a lockfile for the UNIX socket.
	* twisted.internet.unix.Connector: added a checkPID kwarg.  If True,
        it checks that the lockfile for the socket is current.

2004-03-23  Pavel Pergamenshchik  <pp64@cornell.edu>

	* twisted.internet.iocp: Support for Windows IO Completion Ports.
	Use with "--reactor=iocp" parameter to twistd or trial.

2004-03-20  Itamar Shtull-Trauring  <itamar@itamarst.org>

	* twisted.internet: getHost(), getPeer(), buildProtocol() etc.
	all use address objects from twisted.internet.address.

	* twisted/internet/udp.py: Connected UDP support is now part of
	the standard listenUDP-resulting UDP transport using a connect()
	method.

2004-03-18  Jp Calderone  <exarkun@twistedmatrix.com>

	* twisted/application/internet.py: Changed TimerService to
	log errors from the function it calls.

	* twisted/application/test_application.py: Added test case
	for logging of exceptions from functions TimerService calls.

2004-03-07  Christopher Armstrong  <radix@twistedmatrix.com>

	* .: Releasing Twisted 1.2.1alpha1.

2004-03-03  Christopher Armstrong  <radix@twistedmatrix.com>

	* twisted/web/server.py: Fix UnsupportedMethod so that users'
	allowedMethods are actually honored.

	* twisted/web/resource.py: (Resource.render) If the resource has
	an 'allowedMethods' attribute, pass it to UnsupportedMethod.

2004-02-27  Andrew Bennetts  <spiv@twistedmatrix.com>

	* twisted/internet/defer.py: Add consumeErrors flag to DeferredList.
	This takes care of the most common use-case for the recently
	deprecated addDeferred method.

2004-02-28  Dave Peticolas <dave@krondo.com>

	* setup.py: install tap2rpm as a bin script

	* twisted/test/test_enterprise.py: Test Firebird db. Fix typos.

2004-02-27  Andrew Bennetts  <spiv@twistedmatrix.com>

	* twisted/internet/defer.py: Deprecated DeferredList.addDeferred.  It
	isn't as useful as it looks, and can have surprising behaviour.

2004-02-25  Christopher Armstrong  <radix@twistedmatrix.com>

	* twisted/protocols/dns.py: Fixed a bug in TCP support: It
	wouldn't process any messages after the first, causing AXFR
	queries to be totally broken (in addition to other problems in the
	implementation of AXFR).

	* twisted/names/client.py: Fixed the AXFR client (lookupZone),
	thanks to DJB's wonderful documentation of the horribleness of
	DNS.

2004-02-25  Christopher Armstrong  <radix@twistedmatrix.com>

	* .: Releasing Twisted 1.2.0 final! Same as rc3.

2004-02-24  Christopher Armstrong  <radix@twistedmatrix.com>

	* .: Releasing Twisted 1.2.0rc3 (same as rc2, with cBanana bug
	fixed).

2004-02-19  Kevin Turner  <acapnotic@twistedmatrix.com>

	* twisted/application/service.py (IService.disownServiceParent)
	(IServiceCollection.removeService): These may return Deferred if they
	have asynchronous side effects.

2004-02-18  Christopher Armstrong  <radix@twistedmatrix.com>

	* .: Releasing Twisted 1.2.0rc2. Brown-paper bag release bug.

2004-02-17  Christopher Armstrong  <radix@twistedmatrix.com>

	* .: Releasing Twisted 1.2.0rc1.

2004-02-13  Brian Warner  <warner@lothar.com>

	* doc/howto/faq.xhtml: add entry on transport.getPeer()

2004-01-31  Christopher Armstrong  <radix@twistedmatrix.com>

	* .: Releasing Twisted 1.1.2alpha2 (problem with Debian packaging).

2004-01-30  Christopher Armstrong  <radix@twistedmatrix.com>

	* .: Releasing Twisted 1.1.2alpha1.

2004-01-23  Christopher Armstrong  <radix@twistedmatrix.com>

	* twisted/scripts/trial.py: trial now supports a --coverage
	option, requiring Python 2.3.3. Give it a directory name (relative
	to _trial_temp) to put code-coverage info in. It uses the stdlib
	'trace' module.

2004-01-21  Pavel Pergamenshchik  <pp64@cornell.edu>

	* twisted/protocols/stateful.py: A new way to write protocols!
	Current state is encoded as a pair (func, len). As soon as len
	of data arrives, func is called with that amount of data.  New
	state is returned from func.
	* twisted/test/test_stateful.py: Tests and an example, an
	Int32StringReceiver implementation.

2004-01-18  Christopher Armstrong  <radix@twistedmatrix.com>

	* twisted/web/resource.py: The default render method of Resource
	now supports delegating to methods of the form "render_*" where
	"*" is the HTTP method that was used to make the
	request. Examples: request_GET, request_HEAD, request_CONNECT, and
	so on. This won't break any existing code - when people want to
	use the better API, they can stop overriding 'render' and instead
	override individual render_* methods.

2004-01-13  Itamar Shtull-Trauring  <itamar@itamarst.org>

	* twisted/web/soap.py: Beginning of client SOAP support.

2004-01-10  Andrew Bennetts <spiv@twistedmatrix.com>

	* twisted/protocols/ftp.py: Added support for partial downloads
	and uploads to FTPClient (see the offset parameter of retrieveFile).

2004-01-09  Jp Calderone  <exarkun@twistedmatrix.com>

	* twisted/protocols/imap4.py: Add IMessageCopier interface to allow
	for optimized implementations of message copying.

2004-01-06  Brian Warner  <warner@lothar.com>

	* twisted/internet/default.py (PosixReactorBase.spawnProcess): add
	a 'childFDs' argument which allows the child's file descriptors to
	be arbitrarily mapped to parent FDs or pipes. This allows you to
	set up additional pipes into the child (say for a GPG passphrase
	or separate status information).

	* twisted/internet/process.py (Process): add childFDs, split out
	ProcessReader and ProcessWriter (so that Process itself is no
	longer also reading stdout).

	* twisted/internet/protocol.py (ProcessProtocol): add new
	childDataReceived and childConnectionLost methods, which default
	to invoking the old methods for backwards compatibility

	* twisted/test/test_process.py (FDTest): add test for childFDs
	mapping. Also add timeouts to most tests, and make all
	reactor.iterate() loops wait 10ms between iterations to avoid
	spamming the CPU quite so badly. Closes issue435.
	* twisted/test/process_fds.py: new child process for FDTest

	* doc/howto/process.xhtml: document childFDs argument, add example

2004-01-04  Itamar Shtull-Trauring  <itamar@itamarst.org>

	* twisted/internet/gladereactor.py: logs all network traffic for
	TCP/SSL/Unix sockets, allowing traffic to be displayed.

2004-01-04  Dave Peticolas  <dave@krondo.com>

	* twisted/test/test_enterprise.py: test deleting rows not in cache

	* twisted/enterprise/reflector.py: deleted rows don't have to be
	in cache

	* doc/examples/row_example.py: use KeyFactory from row_util

	* doc/examples/row_util.py: add KeyFactory

2003-12-31  Brian Warner  <warner@lothar.com>

	* twisted/internet/defer.py (Deferred.setTimeout): if the Deferred
	has already been called, don't bother with the timeout. This
	happens when trial.util.deferredResult is used with a timeout
	argument and the Deferred was created by defer.succeed().
	* twisted/test/test_defer.py
	(DeferredTestCase.testImmediateSuccess2): test for same

2003-12-31  Jp Calderone  <exarkun@twistedmatrix.com>

	* twisted/protocols/ident.py: Client and server ident implementation
	* twisted/test/test_ident.py: Test cases for ident protocol

2003-12-29  Jp Calderone  <exarkun@twistedmatrix.com>

	* twisted/spread/pb.py: Changed PBServerFactory to use "protocol"
	instance attribute for Broker creation.

2003-12-26  Itamar Shtull-Trauring  <itamar@itamarst.org>

	* twisted/web/server.py: display of tracebacks on web pages can
	now be disabled by setting displayTracebacks to False on the Site
	or by using applicable tap option. Woven does not yet use
	this attribute.

2003-12-23  Itamar Shtull-Trauring  <itamar@itamarst.org>

	* twisted/web/client.py: if Host header is passed, use that
	instead of extracting from request URL.

2003-12-14  Dave Peticolas  <dave@krondo.com>

	* twisted/test/test_enterprise.py: Frederico Di Gregorio's patch
	adding a psycopg test case.

2003-12-09  Christopher Armstrong  <radix@twistedmatrix.com>

	* .: Releasing Twisted 1.1.1, based on rc4.

2003-12-06  Itamar Shtull-Trauring  <itamar@itamarst.org>

	* twisted/internet/wxreactor.py: Added experimental wxPython reactor,
	which seems to work better than the twisted.internet.wxsupport.

2003-12-05  Paul Swartz  <z3p@twistedmatrix.com>

	* twisted/conch/ssh/filetransfer.py, session.py: added SFTPv3 support
	to the Conch server.

2003-12-04  Christopher Armstrong  <radix@twistedmatrix.com>

	* .: Releasing Twisted 1.1.1rc4, based on rc2. rc3 never happened!

2003-12-04  Brian Warner  <warner@lothar.com>

	* twisted/persisted/sob.py (Persistent): fix misspelled class name,
	add compatibility binding to "Persistant" (sic).

	* twisted/test/test_sob.py: use Persistent
	* twisted/application/service.py (Application): use Persistent

2003-12-03  Jp Calderone  <exarkun@twistedmatrix.com>

	* twisted/protocols/imap4.py: Added support for the
	IDLE command (RFC 2177).

2003-12-03  Jp Calderone  <exarkun@twistedmatrix.com>

	* twisted/python/log.py: Added exception handling to
	log publishing code.  Observers which raise exceptions
	will now be removed from the observer list.

2003-12-02  Jp Calderone  <exarkun@twistedmatrix.com>

	* .: Releasing Twisted 1.1.1rc3.

2003-12-01  Christopher Armstrong  <radix@twistedmatrix.com>

	* .: Releasing Twisted 1.1.1rc2 (from CVS HEAD).

2003-12-01  Jp Calderone  <exarkun@twistedmatrix.com>

	* twisted/python/runtime.py: Added seconds method to Platform
	class.

	* twisted/internet/base.py, twisted/internet/task.py: Changed
	use of time.time() to use Platform.seconds() instead.

2003-11-24  Jp Calderone  <exarkun@twistedmatrix.com>

	* twisted/internet/abstract.py: Changed FileDescriptor's
	registerProducer method to immediately call the given producer's
	stopProducing method if the FileDescriptor is in the process of
	or has finished disconnecting.

2003-11-24  Jp Calderone  <exarkun@twistedmatrix.com>

	* twisted/protocols/imap4.py: Fix incorrect behavior of closing the
	mailbox in response to an EXPUNGE command.

2003-11-21  Jp Calderone  <exarkun@twistedmatrix.com>

	* twisted/trial/runner.py: Added missing calls to setUpClass and
	tearDownClass in SingletonRunner.

2003-11-21  Christopher Armstrong  <radix@twistedmatrix.com>

	* .: Releasing Twisted 1.1.1rc1.

2003-11-20  Jp Calderone  <exarkun@twistedmatrix.com>

	* twisted/protocols/imap4.py: Fixed incorrect generation of
	INTERNALDATE information.

2003-11-20  Jp Calderone  <exarkun@twistedmatrix.com>

	* twisted/internet/abstract.py: Added an assert to
	FileDescriptor.resumeProducing to prevent it from being
	called when the transport is no longer connected.

2003-11-20  Jp Calderone  <exarkun@twistedmatrix.com>

	* twisted/internet/tasks.py: LoopingCall added.

2003-10-14  Itamar Shtull-Trauring  <itamar@itamarst.org>

	* twisted/internet/tasks.py: Deprecated scheduling API removed.

2003-11-18  Jonathan Simms  <jonathan@embassynetworks.com>

	* twisted/protocols/ftp.py: refactored to add cred support,
	pipelining, security.
	* twisted/test/test_ftp.py: tests for the new ftp

2003-11-18  Sam Jordan  <sam@twistedmatrix.com>

	* twisted/protocols/msn.py: support for MSNP8
	* doc/examples/msn_example.py: small msn example

2003-11-13  Paul Swartz  <z3p@twistedmatrix.com>

	* twisted/conch/ssh/agent.py: support for the OpenSSH agent protocol
	* twisted/conch/ssh/connection.py: fix broken channel retrieval code
	* twisted/conch/ssh/userauth.py: refactoring to allow use of the agent
	* twisted/conch/ssj/transport.py: fix intermittent test failure
	* twisted/internet/protocol.py: add UNIX socket support to
	ClientCreator
	* twisted/scripts/conch.py: use the key agent if available, also
	agent forwarding

2003-11-07  Brian Warner  <warner@lothar.com>

	* twisted/application/app.py (getApplication): provide a more
	constructive error message when a .tac file doesn't define
	'application'. Closes issue387.

2003-11-01  Paul Swartz  <z3p@twistedmatrix.com>

	* twisted/conch/ssh/common.py: use GMPy for faster math if it's
	available

2003-10-24  Christopher Armstrong  <radix@twistedmatrix.com>

	* .: Releasing Twisted 1.1.0 final. Same codebase as rc2.

2003-10-24  Brian Warner  <warner@lothar.com>

	* doc/howto/test-standard.xhtml: Add section on how to clean up.

	* twisted/test/test_conch.py: improve post-test cleanup. Addresses
	problems seen in issue343.

	* twisted/internet/base.py (ReactorBase.callLater): prefix
	"internal" parameter names with an underscore, to avoid colliding
	with named parameters in the user's callback invocation. Closes
	issue347.
	(ReactorBase.addSystemEventTrigger)
	(ReactorBase.callWhenRunning)
	(ReactorBase.callInThread): same
	* doc/howto/coding-standard.xhtml (Callback Arguments): explain why

2003-10-22  Christopher Armstrong  <radix@twistedmatrix.com>

	* .: Releasing Twisted 1.1.0rc2.

2003-10-21  Andrew Bennetts  <spiv@twistedmatrix.com>

	* twisted/lore/tree.py, twisted/lore/lint.py,
	doc/howto/stylesheet.css: add a plain 'listing' class, for file
	listings that aren't python source or HTML.  This has slightly changed
	the classes in the generated HTML, so custom stylesheets may need
	updating.

2003-10-16  Christopher Armstrong  <radix@twistedmatrix.com>

	* .: Releasing Twisted 1.1.0alpha3.

2003-10-16  Brian Warner  <warner@lothar.com>

	* doc/howto/pb-cred.xhtml: update for newcred. Closes issue172.

2003-10-15  Brian Warner  <warner@lothar.com>

	* twisted/internet/base.py: add optional debug code, enabled with
	base.DelayedCall.debug=True . If active, the call stack which
	invoked reactor.callLater will be recorded in each DelayedCall. If
	an exception happens when the timer function is run, the creator
	stack will be logged in addition to the usual log.deferr().

	* twisted/internet/defer.py: add some optional debug code, enabled
	with defer.Deferred.debug=True . If active, it will record a stack
	trace when the Deferred is created, and another when it is first
	invoked. AlreadyCalledErrors will be given these two stack traces,
	making it slightly easier to find the source of the problem.

2003-10-15  Christopher Armstrong  <radix@twistedmatrix.com>

	* .: Releasing Twisted 1.1.0alpha2 (alpha1 was dead in the water).

2003-10-15  Brian Warner  <warner@lothar.com>

	* setup.py: remove cReactor/ to the sandbox. Closes issue318.

2003-10-14  Itamar Shtull-Trauring  <itamar@itamarst.org>

	* twisted/web/static.py: registry no longer has support for
	getting services based on their interfaces.

2003-10-14  Christopher Armstrong  <radix@twistedmatrix.com>

	* .: Releasing Twisted 1.1.0alpha1.

2003-10-13  Bob Ippolito  <bob@redivi.com>

	* doc/howto/choosing-reactor.xhtml:
	Added cfreactor/Cocoa information.

	* doc/examples/cocoaDemo:
	Removed, replaced by doc/examples/Cocoa cfreactor demos.

	* doc/examples/Cocoa:
	Moved from sandbox/etrepum/examples/PyObjC, cleaned up.

	* twisted/internet/cfsupport, twisted/internet/cfreactor.py:
	Moved from sandbox/etrepum, cleaned up.

	* twisted/application/app.py:
	Added 'cf' -> twisted.internet.cfreactor to reactorTypes

	* setup.py:
	sys.platform=='darwin' - build cfsupport, do not build cReactor.

	* INSTALL:
    Changed URL of pimp repository to shorter version.

2003-10-12  Jp Calderone  <exarkun@twistedmatrix.com>

	* bin/tktwistd, twisted/scripts/tktwistd.py, doc/man/tktwistd.1:
	Removed.

2003-10-12  Itamar Shtull-Trauring  <itamar@itamarst.org>

	* twisted/spread/pb.py: Perspective Broker no longer sends
	detailed tracebacks over the wire unless the "unsafeTracebacks"
	attribute is set of the factory.

2003-10-02  Jp Calderone  <exarkun@twistedmatrix.com>

	* setup.py, twisted/test/test_dir.py, twisted/python/_c_dir.c:
	Removed _c_dir extension module for portability and maintenance
	reasons.

2003-10-03  Moshe Zadka <moshez@twistedmatrix.com>

	* twisted/spread/util.py twisted/test/test_spread.py: Fix issue
	286

2003-10-01  Brian Warner  <warner@lothar.com>

	* twisted/web/client.py (HTTPDownloader): accept either a filename
	or a file-like object (it must respond to .write and .close, and
	partial requests will not be used with file-like objects). errback
	the deferred if an IOError occurs in .open, .write. or .close,
	usually something like "permission denied" or "file system full".
	Closes issue234.
	* twisted/test/test_webclient.py (WebClientTestCase.write): verify
	that the errback gets called

	* twisted/scripts/trial.py (run): add --until-failure option to
	re-run the test until something fails. Closes issue87.

2003-09-30  Brian Warner  <warner@lothar.com>

	* twisted/test/test_conch.py (testOurServerOpenSSHClient): replace
	reactor.run() with .iterate calls: when using .run, exceptions in
	the server cause a hang.

2003-9-29  Moshe Zadka <moshez@twistedmatrix.com>

	* twisted/tap/procmon.py twisted/plugins.tml: remove procmon
	tap. It was crufty and hard to port properly to new application.

2003-09-29  Brian Warner  <warner@lothar.com>

	* twisted/scripts/trial.py (Options.opt_reactor): make trial
	accept the same reactor-name abbreviations as twistd does. Closes
	issue69.
	(top): add test-case-name tag

	* doc/man/trial.1: document the change

2003-09-28  Christopher Armstrong  <radix@twistedmatrix.com>

	* .: Releasing Twisted 1.0.8alpha3.

2003-09-27  Cory Dodt <corydodt@yahoo.com>

	* win32/main.aap win32/pyx.x-foo.iss.template win32/README.win32:
	Be nice to people who don't install Python for "All Users" on win32.

2003-9-18  Moshe Zadka <moshez@twistedmatrix.com>

	* twisted/application/strports.py twisted/test/test_strports.py:
	New API/mini-language for defining ports

2003-9-18  Moshe Zadka <moshez@twistedmatrix.com>

	* twisted/web/spider.py: removed, it was unmaintained.

2003-09-19  Christopher Armstrong  <radix@twistedmatrix.com>

	* twisted/names/authority.py twisted/test/test_names.py
	twisted/protocols/dns.py: Client and server support for TTLs on
	all records. All Record_* types now take a ttl= keyword
	argument. You can pass the ttl= argument to all the record classes
	in your pyzones, too.

2003-09-19  Moshe Zadka <moshez@twistedmatrix.com>

	* twisted/application/__init__.py twisted/application/app.py
        twisted/application/compat.py twisted/application/internet.py
        twisted/application/service.py twisted/scripts/twistd.py
        twisted/scripts/twistw.py twisted/scripts/mktap.py
        twisted/scripts/tapconvert.py bin/twistw: Update to new-style
	applications.

2003-09-19  Jp Calderone  <exarkun@twistedmatrix.com>

	* twisted/names/client.py: Instantiation of theResolver global made
	lazy.  As a result importing it directly will now fail if it has not
	yet been created.  It should not be used directly anymore; instead,
	use the module-scope lookup methods, or instantiate your own
	resolver.

	* twisted/mail/relaymanager.py: Instantiation of MXCalculator made
	lazy.

2003-09-18  Stephen Thorne  <stephen@thorne.id.au>

	* twisted/web/distrib.py: Removed dependancy on twisted.web.widgets, and
	instead using woven.

2003-09-18  Stephen Thorne  <stephen@thorne.id.au>

	* doc/howto/woven-reference.html: Added this new documentation file.
	* doc/howto/index.html: Added woven-reference to index
	* admin/: Added woven-reference.tex to book.tex

2003-09-18  Stephen Thorne  <stephen@thorne.id.au>

	* twisted/web/woven/widgets.py: Stop the 'Option' widget from having a
    name="" attribute. Closes issue255.

2003-09-16  Christopher Armstrong  <radix@twistedmatrix.com>

	* .: Releasing Twisted 1.0.8alpha1.

	* .: Releasing Twisted 1.0.8alpha2 (Fixed Debian packages).

2003-09-13  Christopher Armstrong  <radix@twistedmatrix.com>

	* .: Releasing Twisted 1.0.7 (no code changes since 1.0.7rc1).

	* twisted/web/vhost.py: Un-gobble the path segment that a vhost eats
	when the resource we're wrapping isLeaf. Potentially closes issue125.

2003-09-12  Itamar Shtull-Trauring  <itamar@itamarst.org>

	* twisted/web/microdom.py: lenient mode correctly handles <script>
	tags with CDATA or comments protecting the code (closes issue #231).

2003-09-10  Tommi Virtanen  <tv@twistedmatrix.com>

	* HTTPS support for XML-RPC and web clients (closes issue #236).

2003-08-29  Christopher Armstrong  <radix@twistedmatrix.com>

	* .: Releasing Twisted 1.0.7rc1.

2003-09-12  Itamar Shtull-Trauring  <itamar@itamarst.org>

	* twisted/spread/pb.py: new cred support for Perspective Broker.

2003-08-26  Dave Peticolas  <dave@krondo.com>

	* doc/howto/xmlrpc.html: document sub-handler and introspection

	* twisted/test/test_xmlrpc.py: test introspection support

	* twisted/web/xmlrpc.py: implement sub-handlers and introspection
	support

2003-08-23  Brian Warner  <warner@lothar.com>

	* twisted/internet/gtk2reactor.py: force timeout values to be
	integers, because recent pygtk's complain when they get floats

2003-08-19  Christopher Armstrong  <radix@twistedmatrix.com>

	* .: Releasing Twisted 1.0.7alpha5.

2003-08-18  Jp Calderone <exarkun@twistedmatrix.com>

	* twisted/protocols/imap4.py: Remove support code for old versions
	of IMailbox.fetch(); also change the interface once again (no
	backwards compat this time) to require sequence numbers to be
	returned, not just whatever the MessageSet spit out.

2003-08-16  Dave Peticolas  <dave@krondo.com>

	* twisted/test/test_import.py: update for enterprise

	* twisted/enterprise/sqlreflector.py: use dbpool directly

	* twisted/enterprise/row.py: deprecate KeyFactory and StatementBatch

	* twisted/enterprise/dbpassport.py: remove

	* twisted/enterprise/dbgadgets.py: deprecate all

	* twisted/enterprise/dbcred.py: deprecate all

	* twisted/enterprise/adbapi.py: deprecate Augmentation. deprecate
	crufty bits of ConnectionPool API.

2003-08-11  Dave Peticolas  <dave@krondo.com>

	* twisted/enterprise/sqlreflector.py: fix docs

2003-08-08  Donovan Preston  <dp@twistedmatrix.com>

	* Added getAllPatterns API to Widget, which returns all nodes
	which have the given pattern name.

	* Refactored List widget to use getAllPatterns, so you can have
	more than one listHeader, listFooter, and emptyList node.

2003-08-08  Dave Peticolas  <dave@krondo.com>

	* twisted/internet/base.py: remove unused internal function.

	* twisted/internet/gladereactor.py: remove unused internal function.
	clean up imports.

2003-08-07  Christopher Armstrong  <radix@twistedmatrix.com>

	* .: Releasing Twisted 1.0.7alpha4.

2003-08-06  Donovan Preston <dp@twistedmatrix.com>

	* Major woven optimizations.

	* Removal of inspect-based hacks allowing backwards compatibility
	with the old IModel interface. All your IModel methods should take
	the request as the first argument now.

	* Default to non-case-preserving when importing Woven templates,
	and case-insensitive microdom. If you are using getPattern or
	getAttribute in any of your woven code, you will have to make sure
	to pass all lowercase strings.

	* Removal of __eq__ magic methods in microdom. This was just
	slowing woven down far too much, since without it python can
	use identity when looking for a node in replaceChild. This means
	you will have to explicitly use the isEqualToDocument or
	isEqualToNode call if you are testing for the equality of microdom
	nodes.

	* Removal of usage of hasAttribute, getAttribute, removeAttribute
	from woven for a speed gain at the expense of tying woven slightly
	closer to microdom. Nobody will notice.

	* Improved getPattern semantics thanks to a patch by Rich
	Cavenaugh. getPattern will now not look for a pattern below any
	nodes which have model= or view= directives on them.

2003-08-04  Dave Peticolas  <dave@krondo.com>

	* twisted/python/usage.py: use parameter docs if handler
	method has none. fixes bug displaying trial help.

2003-07-31  Brian Warner  <warner@lothar.com>

	* twisted/python/filepath.py (FilePath.__getstate__): allow
	FilePath objects to survive unpersisting.

2003-07-30  Brian Warner  <warner@lothar.com>

	* doc/howto/faq.html: mention spawnProcess vs. os.environ

	* doc/howto/test-standard.html: document usage of .todo and .skip

2003-07-28  Brian Warner  <warner@lothar.com>

	* twisted/python/_c_dir.c: hush compiler warning

	* setup.py: add twisted.xish

2003-07-28  Itamar Shtull-Trauring  <itamar@itamarst.org>

	* twisted/spread/pb.py (PBClientFactory): a new, superior API for
	starting PB connections. Create a factory, do a
	reactor.connectTCP/SSL() etc., then factory.getPerspective().

2003-07-27  Dave Peticolas  <dave@krondo.com>

	* twisted/test/test_enterprise.py: enable tests that depend on
	cp_min and cp_max

	* twisted/enterprise/adbapi.py: use threadpool to handle cp_min and
	cp_max arguments

	* twisted/test/test_threadpool.py: test existing work

	* twisted/python/threadpool.py: check for existing work in start()

2003-07-25  Jp Calderone  <exarkun@twistedmatrix.com>

	* twisted/protocols/imap4.py: The fetch method of the IMailbox
	interface has been changed to accept only a MessageSet and a uid
	argument and to return an IMessage implementor.

2003-07-24  Brian Warner  <warner@lothar.com>

	* twisted/internet/cReactor/cDelayedCall.c: implement .active and
	.getTime methods

	* twisted/test/test_internet.py (InterfaceTestCase.wake): remove
	reactor.initThreads() call. This is a private method which is
	triggered internally by the current reactor when threadable.init
	is called. It does not need to be called independently, and not
	all reactors implement this particular method.

	* twisted/test/test_threads.py: shuffle test cases, add timeouts
	to avoid hanging tests. Added (disabled) test to trigger cReactor
	hang (but unfortunately it fails under the default reactor)

2003-07-23  Dave Peticolas  <dave@krondo.com>

	* twisted/internet/threads.py: avoid top-level reactor import

2003-07-23  Jp Calderone  <exarkun@twistedmatrix.com>

	* twisted/protocols/imap4.py: The fetch method of the IMailbox
	interface has been changed to accept a list of (non-string)
	objects representing the requested message parts.  Less knowledge
	of the IMAP4 protocol should be required to properly implement
	the interface.

2003-07-23  Dave Peticolas  <dave@krondo.com>

	* twisted/test/test_enterprise.py: more tests

2003-07-21  Dave Peticolas  <dave@krondo.com>

	* twisted/internet/base.py: implement callWhenRunning

	* twisted/internet/interfaces.py: add callWhenRunning API

	* twisted/test/test_pop3.py: string in string only works in 2.3

2003-07-19  Christopher Armstrong  <radix@twistedmatrix.com>

	* .: Releasing Twisted 1.0.7alpha3 (for form and twisted.names
	updates mentioned below).

2003-07-19  Ying Li <cyli@ai.mit.edu>

	* twisted/web/woven/form.py:  Changed form widgets so that if the
	template already has the widget coded, merges the template widget
	with the model widget (sets default values, etc.).

	* twisted/web/woven/form.py, twisted/python/formmethod.py:  Can
	format layout of checkgroups and radiogroups into tables, rows, or
	columns.

	* twisted/web/woven/form.py, twisted/python/formmethod.py: Added
	file input widget (unable to retrieve filename or file type - have
	to ask for that separately).

2003-07-19  Christopher Armstrong  <radix@twistedmatrix.com>

	* twisted/protocols/dns.py, twisted/names: Twisted Names can now
	return the `authoritative' bit. All of the resolvers in
	twisted/names/authority.py now set it.

2003-07-17  Christopher Armstrong  <radix@twistedmatrix.com>

	* .: Releasing Twisted 1.0.7alpha2 (Debian packages should be
	correct	now)

2003-07-17  Dave Peticolas  <dave@krondo.com>

	* doc/howto/components.html: methods in interfaces do have self
	parameters

2003-07-18  Christopher Armstrong  <radix@twistedmatrix.com>

	* twisted/web/client.py: Added a `timeout' keyword argument to
	getPage; If the web page takes longer than `timeout' to fetch,
	defer.TimeoutError is errbacked.

	* twisted/web/server.py, twisted/protocols/http.py: add `timeout'
	argument to HTTPFactory and Site to specify how long to allow
	connections to sit without communication before disconnecting
	them.

2003-07-18  Christopher Armstrong  <radix@twistedmatrix.com>

	* .: Releasing Twisted 1.0.7alpha1.

2003-07-17  Jp Calderone  <exarkun@twistedmatrix.com>

	* twisted/protocols/smtp.py: Address class changed to provide a
	default domain for addresses missing a domain part.

2003-07-16  Christopher Armstrong  <radix@twistedmatrix.com>

	* twisted/protocols/sux.py: In beExtremelyLenient mode, all data
	in script elements is considered plain text and will not be parsed
	for tags or entity references.

2003-07-15  Dave Peticolas  <dave@krondo.com>

	* twisted/persisted/styles.py: better debugging output
	for Ephemeral

2003-07-14  Jp Calderone  <exarkun@twistedmatrix.com>

	* twisted/cred/checkers.py, twisted/cred/credentials.py:
	CramMD5Credentials and OnDiskUsernamePasswordDatabase added;
	IUsernameHashedPassword also created for use by protocols that
	do not receive plaintext passwords over the network.

	* twisted/mail/, twisted/protocols/smtp.py: Addition of alias
	support and authenticated ESMTP connections.  Several interfaces
	changed, but deprecation warnings and backwards compatibility code
	has been put in place to ease the change.

2003-07-12  Christopher Armstrong  <radix@twistedmatrix.com>

	* twisted/web/util.py: Add a new ChildRedirector that, when placed
	at /foo to redirect to /bar, will also redirect /foo/abc to
	/bar/abc.

	* twisted/web/scripts.py: Fixed ResourceScriptWrapper so that you
	can now .putChild on the resource you create in an .rpy file that
	is wrapped with this class.

2003-07-06  Paul Swartz  <z3p@twistedmatrix.com>
	* twisted/conch/[checkers,credentials,pamauth].py,
	  twisted/conch/ssh/userauth.py, twisted/tap/conch.py: made PAM
	  work again as an authentication.

2003-07-05  Dave Peticolas  <dave@krondo.com>

	* twisted/test/test_enterprise.py: more tests. Add mysql test.

2003-07-05  Itamar Shtull-Trauring  <itamar@itamarst.org>

	* twisted/web/soap.py: Now requires SOAPpy v0.10.1, allow subclasses
	to determine method publishing strategy.

2004-07-05  Jp Calderone  <exarkun@twistedmatrix.com>

	* bin/mailmail, doc/man/mailmail.1, twisted/scripts/mailmail.py:
	sendmail replacement

2003-07-04  Dave Peticolas  <dave@krondo.com>

	* twisted/test/test_enterprise.py: add sqlite. more tests.
	Add Postgres test.

	* twisted/enterprise/util.py: fix bug in getKeyColumn

	* twisted/enterprise/sqlreflector.py: clean up imports

	* twisted/enterprise/row.py: clean up imports

	* twisted/enterprise/reflector.py: clean up imports

2004-07-04  Jp Calderone  <exarkun@twistedmatrix.com>

	* twisted/python/dir.c: Wrapper around opendir(3), readdir(3),
	and scandir(3) for use by twisted.python.plugins.

2003-07-03  Jp Calderone  <exarkun@twistedmatrix.com>

	* twisted/news/database.py: NewsShelf.articleRequest() and
	NewsShelf.bodyRequest() now expected to return a file-like object
	in the last position of its returned three-tuple.  The old API
	is still supported, but deprecated.

2003-07-03  Dave Peticolas  <dave@krondo.com>

	* twisted/test/test_enterprise.py: add gadfly test

	* twisted/web/woven/input.py: remove excess newline.

	* twisted/trial/unittest.py: take out unused methodPrefix var

	* twisted/enterprise/adbapi.py: accept 'noisy' kw arg. persist
	noisy, min, and max args. just warn about non-dbapi db libs.

	* twisted/enterprise/reflector.py: fix spelling

	* twisted/enterprise/sqlreflector.py 80 columns, don't addToCache
	in insertRow

	* twisted/enterprise/xmlreflector.py: 80 columns

2003-07-01  Brian Warner  <warner@lothar.com>

	* sandbox/warner/fusd_twisted.py: experimental glue code for FUSD,
	a system for implementing Linux device drivers in userspace

2003-06-27  Christopher Armstrong  <radix@twistedmatrix.com>

	* .: Releasing Twisted 1.0.6rc3. Fixed a security bug in
	twisted.web.

	* .: Releasing Twisted 1.0.6rc4. One more twisted.web bug.

	* .: Releasing Twisted 1.0.6.

2003-06-26  Christopher Armstrong  <radix@twistedmatrix.com>

	* .: Releasing Twisted 1.0.6rc1.

	* .: Releasing Twisted 1.0.6rc2. Pop3 had failing tests.

2003-06-26  Clark C. Evans  <cce@twistedmatrix.com>

	* twisted/flow/*.py: Moved Flow from the sandbox to
	twisted.flow. The callback is dead. Long live the callback!

2003-06-26  Jp Calderone  <exarkun@twistedmatrix.com>

	* twisted/protocols/pop3.py: POP3.authenticateUserXYZ no longer
	returns a Mailbox object. It now returns a 3-tuple. See
	twisted.cred.portal.Portal.login for more details about the return
	value.

2003-06-24  Brian Warner  <warner@lothar.com>

	* doc/howto/upgrading.html: Explain Versioned and rebuild()

2003-06-23  Christopher Armstrong  <radix@twistedmatrix.com>

	* twisted/scripts/trial.py twisted/trial/reporter.py
	doc/man/trial.1:

	Added a --tbformat={plain,emacs} option to trial. Now the default
	is to show the regular python traceback; if you want tracebacks
	that look like compiler output for emacs, use --tbformat=emacs.

2003-06-23  Cory Dodt <corydodt@yahoo.com>

	* twisted/python/util.py twisted/web/microdom.py
	twisted/test/test_{util,xml}.py: preserveCase and caseInsensitive
	work on attribute names as well as element names.

2003-06-22  Jp Calderone  <exarkun@twistedmatrix.com>

	* twisted/internet/defer.py: Changed maybeDeferred API from
	maybeDeferred(deferred, f, *args, **kw) to maybeDeferred(f, *args,
	**kw).

2003-06-19  Paul Swartz  <z3p@twistedmatrix.com>

	* twisted/conch/{checkers,credentials,realm}.py,
	twisted/conch/ssh/userauth.py: Moved the Conch user authentication
	code to use the new version of Cred.

2003-06-19  Christopher Armstrong  <radix@twistedmatrix.com>

	* .: Releasing Twisted 1.0.6alpha3. There was a problem in
	twisted.python.compat that was breaking the documentation
	building. It is now fixed.

2003-06-18  Christopher Armstrong  <radix@twistedmatrix.com>

	* .: Releasing Twisted 1.0.6alpha2.

2003-06-16  Donovan Preston  <dp@twistedmatrix.com>

	* twisted/web/woven/{controller,view,widgets}.py: Cleaned up the
	output of Woven so it never leaves any woven-specific attributes
	on the output HTML. Also, id attributes are not set on every
	node with a View unless you are using LivePage.

2003-06-11  Brian Warner  <warner@lothar.com>

	* doc/howto/cvs-dev.html: add "Working from CVS" hints

2003-06-10  Itamar Shtull-Trauring  <itamar@itamarst.org>

	* twisted/internet/protocol.py: connection refused errors for
	connected datagram protocols (connectUDP) are indicated using
	callback, ConnectedDatagramProtocol.connectionRefused, rather
	than an exception as before.

2003-06-09  Christopher Armstrong  <radix@twistedmatrix.com>

	* twisted/trial/{unittest,runner}.py: Added setUpClass and
	tearDownClass methods and invocations to twisted.trial. Implement
	those methods in your TestCases if you want to manage resources on
	a per-class level.

2003-06-09  Jp Calderone  <exarkun@twistedmatrix.com>

	* twisted/mail/relay.py: Default relaying rule change from all
	local and all non-INET connections to all local and all UNIX
	connections.

2003-06-08  Jp Calderone  <exarkun@twistedmatrix.com>

	* twisted/internet/interfaces.py: Added ITLSTransport interface,
	subclassing ITCPTransport and adding one method - startTLS()

	* twisted/internet/tcp.py: Connector class made to implement
	ITLSTransport if TLS is available.

2003-06-05  Brian Warner  <warner@lothar.com>

	* twisted/conch/ssh/transport.py (ssh_KEX_DH_GEX_INIT): don't use
	small values for DH parameter 'y'. openssh rejects these because they
	make it trivial to reconstruct the shared secret. This caused a test
	failure about 1024 times out of every 65536.

	* twisted/test/test_dirdbm.py (DirDbmTestCase.testModificationTime):
	dodge a kernel bug that lets mtime get skewed from time(), causing
	an occasional test failure

2003-06-03  Jp Calderone    <exarkun@twistedmatrix.com>

	* twisted/__init__.py twisted/internet/app.py
	* twisted/internet/unix.py twisted/internet/tcp.py
	* twisted/manhole/ui/gtk2manhole.py twisted/protocols/dns.py
	* twisted/protocols/smtp.py twisted/protocols/sux.py
	* twisted/protocols/imap4.py twisted/protocols/sip.py
	* twisted/protocols/htb.py twisted/protocols/pcp.py
	* twisted/python/formmethod.py twisted/python/reflect.py
	* twisted/python/util.py twisted/python/components.py
	* twisted/spread/jelly.py twisted/spread/newjelly.py
	* twisted/test/test_components.py twisted/test/test_rebuild.py
	* twisted/test/test_trial.py twisted/test/test_world.py
	* twisted/test/test_setup.py twisted/test/test_newjelly.py
	* twisted/test/test_compat.py twisted/test/test_pcp.py
	* twisted/test/test_log.py twisted/web/microdom.py
	* twisted/web/woven/page.py twisted/popsicle/mailsicle.py
	* twisted/trial/remote.py twisted/trial/unittest.py
	* twisted/world/allocator.py twisted/world/compound.py
	* twisted/world/database.py twisted/world/storable.py
	* twisted/world/structfile.py twisted/world/typemap.py:

	Remove direct usage of twisted.python.compat; Modify __builtin__
	module to include forward-compatibility hacks.

2003-05-30  Brian Warner  <warner@lothar.com>

	* twisted/conch/ssh/keys.py (signData_dsa): Force DSS signature
	blobs to be 20 bytes long. About 1% of the time, the sig numbers
	would come out small and fit into 19 bytes, which would result in
	an invalid signature.
	* twisted/test/test_conch.py: remove special hacked test case used
	to find that invalid-signature problem.

2003-05-29  Brian Warner  <warner@lothar.com>

	* twisted/python/formmethod.py: this module needs False from compat

	* twisted/internet/process.py (ProcessWriter.writeSomeData):
	Accomodate Mac OS-X, which sometimes raises OSError(EAGAIN)
	instead of IOError(EAGAIN) when the pipe is full.

2003-05-27  Brian Warner  <warner@lothar.com>

	* twisted/test/test_process.py (EchoProtocol): try to close
	occasional test failure. Do transport.closeStdin() instead of
	loseConnection() because the child still has data to write (to
	stderr). Closing all three streams takes away its voice, forces it
	to exit with an error, and is probably causing problems.

	* twisted/test/test_factories.py (testStopTrying): stop test after
	5 seconds rather than 2000 iterations. Some reactors iterate at
	different rates.

2003-05-24  Brian Warner  <warner@lothar.com>

	* twisted/scripts/trial.py (Options.opt_testmodule): ignore
	deleted files, recognize twisted/test/* files as test cases

2003-05-22  Brian Warner  <warner@lothar.com>

	* twisted/test/test_newjelly.py (JellyTestCase.testUnicode): make
	sure unicode strings don't mutate into plain ones

2003-05-21  Brian Warner  <warner@lothar.com>

	* twisted/internet/tcp.py (Connection.getTcpKeepAlive): Add
	functions to control SO_KEEPALIVE bit on TCP sockets.
	* twisted/internet/interfaces.py (ITCPTransport): ditto
	* twisted/test/test_tcp.py (LoopbackTestCase.testTcpKeepAlive):
	test it

	* doc/howto/test-standard.html: document test-case-name format

	* doc/howto/coding-standard.html: encourage test-case-name tags

	* twisted/protocols/htb.py, twisted/protocols/irc.py,
	twisted/protocols/pcp.py, twisted/python/text.py,
	twisted/spread/pb.py, twisted/trial/remote.py: clean up
	test-case-name tags

	* twisted/scripts/trial.py (Options.opt_testmodule): try to handle
	test-case-name tags the same way emacs does

2003-05-21  Christopher Armstrong  <radix@twistedmatrix.com>

	* bin/coil, doc/man/coil.1, doc/man/index.html: removed. Coil
	isn't being maintained, pending a total rewrite.

2003-05-20  Brian Warner  <warner@lothar.com>

	* twisted/python/reflect.py (namedAny): re-raise ImportErrors that
	happen inside the module being imported, instead of assuming that
	it means the module doesn't exist.

2003-05-19  Christopher Armstrong  <radix@twistedmatrix.com>

	* twisted/web/server.py: Added two new methods to Request objects:
	rememberRootURL and getRootURL. Calling rememberRootURL will store
	the already-processed part of the URL on the request, and calling
	getRootURL will return it. This is so you can more easily link to
	disparate parts of your web application.

	* twisted/web/woven/{page,widgets}.py: Updated Woven to take
	advantage of previously-mentioned Request changes. You can now say
	`appRoot = True' in the Page subclass that is instantiated by your
	.rpy (for example), and then use a RootRelativeLink widget
	(exactly the same way you use a Link widget) to get a link
	relative to your root .rpy.

2003-05-16  Brian Warner  <warner@lothar.com>

	* twisted/scripts/trial.py: catch failures during import of test
	modules named on the command line too.

	* twisted/trial/unittest.py (TestSuite.addModule): catch all failures
	during import so that syntax errors in test files don't prevent
	other tests from being run.

	* twisted/trial/reporter.py (TextReporter): handle both Failures
	and exception tuples in import errors. Emit the messages before the
	last summary line so that test-result parsers can still find the
	pass/fail counts.

	* doc/howto/faq.html: Add note about Ephemeral in the
	import-from-self twistd entry.

2003-05-13  Brian Warner  <warner@lothar.com>

	* twisted/trial/runner.py: sort tests by name within a TestCase

2003-05-13  Christopher Armstrong  <radix@twistedmatrix.com>

	* twisted/internet/{default,internet}.py: Add an `active' method to
	DelayedCall, which returns True if it hasn't been called or
	cancelled.

2003-05-13 Jonathan Lange <jml@twistedmatrix.com>

	* twisted/trial/unittest.py twisted/scripts/trial.py
	doc/man/trial.1: Add --recurse option to make trial search within
	sub-packages for test modules.

2003-5-12  Moshe Zadka <moshez@twistedmatrix.com>

	* twisted/lore/default.py twisted/lore/latex.py
	  twisted/lore/lint.py twisted/lore/math.py twisted/lore/tree.py
	  twisted/lore/lmath.py twisted/lore/slides.py:
	  Added indexing support to LaTeX and lint, and made sure the
	  config dictionary is passed to the tree processors [this is an
	  API change which might have effect on Lore extensions!]. Rename
	  math to lmath, to avoid some corner-case bugs where it gets mixed
	  with the Python standard module "math".

2003-05-11  Christopher Armstrong  <radix@twistedmatrix.com>

	* .: Releasing Twisted 1.0.6alpha1. There was a problem
	with file descriptors in 1.0.5; some debugging information
	has been added to this release. The problem should be fixed
	by alpha2.

2003-05-08  Christopher Armstrong  <radix@twistedmatrix.com>

	* .: Releasing Twisted 1.0.5 (same code-base as rc2).

2003-05-08  Glyph Lefkowitz  <glyph@twistedmatrix.com>

	* twisted/world: Added an object database to Twisted.  This is
	still highly experimental!

2003-5-6  Moshe Zadka <moshez@twistedmatrix.com>

	* twisted/trial/reporter.py twisted/scripts/trial.py: Add --timing
	option to make the reporter output wall-clock time.

2003-05-05  Brian Warner  <warner@lothar.com>

	* setup.py (setup_args): s/licence/license/, preferred in python-2.3

2003-05-05  Christopher Armstrong  <radix@twistedmatrix.com>

	* .: Releasing Twisted 1.0.5rc1.

	* .: Releasing Twisted 1.0.5rc2 (only a Debian build problem fixed).

2003-05-05  Brian Warner  <warner@lothar.com>

	* twisted/trial/reporter.py: remove ResultTypes, it doesn't really
	accomplish its goal

	* twisted/trial/unittest.py: move log.startKeepingErrors() from
	top-level to TestSuite.run(). This fixes the problem of errors
	being eaten by code which imports unittest for other reasons (like
	to use trial.remote reporting)

2003-05-04  Brian Warner  <warner@lothar.com>

	* twisted/trial/reporter.py (ResultTypes): export legal values for
	Reporter.reportResults() so remote reporters know what to expect

2003-05-03  Jp Calderone  <exarkun@twistedmatrix.com>

	* twisted/internet/tcp.py, twisted/internet/ssl.py: TLS support
	added to TCP connections; startTLS() method added to transport
	objects to switch from unencrypted to encrypted mode.

2003-05-02  Jp Calderone  <exarkun@twistedmatrix.com>

	* twisted/internet/protocol.py: Added continueTrying attribute to
	ReconnectingClientFactory, and increased the number of states where
	stopTrying() will actually stop further connection attempts.

2003-05-01  Brian Warner  <warner@lothar.com>

	* twisted/test/test_trial.py: handle new trial layout
	* twisted/trial/runner.py (runTest): utility function to help
	test_trial
	* twisted/trial/util.py (extract_tb): handle new trial layout,
	ignore the right framework functions.

2003-05-01  Glyph Lefkowitz  <glyph@twistedmatrix.com>

	* twisted/python/context.py: call-stack context tree.

	* twisted/python/components.py: support interface-to-interface
	adapatation, IFoo(o) syntax for adaptation, context-based
	registries and more.

	* twisted/python/log.py: Totally rewritten logging system.

2003-05-01  Brian Warner  <warner@lothar.com>

	* twisted/internet/gtk2reactor.py (Gtk2Reactor._doReadOrWrite):
	add Anthony's cached-Failure speedup to gtk2 too.

2003-05-01  Itamar Shtull-Trauring  <itamar@itamarst.org>

	* twisted/internet/tcp.py, twisted/internet/default.py: cache
	Failures whose contents are always identical. Speeds up lost
	connections considerably.

	* twisted/python/failure.py: If you pass only an exception object
	to Failure(), a stack will not be constructed. Speeds up Failure
	creation in certain common cases where traceback printing isn't
	required.

2003-04-29  Brian Warner  <warner@lothar.com>

	* twisted/test/test_process.py: make all child processes inherit
	their parent's environment

	* twisted/web/resource.py, twisted/python/roots.py: add
	test-case-name tag

	* twisted/web/resource.py (IResource)
	  twisted/spread/refpath.py (PathReferenceAcquisitionContext.getIndex)
	  twisted/python/roots.py (Collection.getEntity): appease pychecker

2003-04-27  Jp Calderone  <exarkun@twistedmatrix.com>

	* doc/examples/bananabench.py, twisted/internet/utils.py,
	twisted/mail/bounce.py, twisted/persisted/styles.py,
	twisted/python/log.py, twisted/python/reflect.py,
	twisted/spread/pb.py, twisted/test/test_banana.py,
	twisted/test/test_iutils.py, twisted/test/test_persisted.py,
	twisted/test/test_process.py, twisted/web/domhelpers.py,
	twisted/web/script.py, twisted/web/server.py, twisted/web/test.py:
	Change the usage of cStringIO to fallback to StringIO if the former
	is not available.

	* twisted/im/gtkaccount.py, twisted/internet/app.py,
	twisted/mail/relay.py, twisted/mail/relaymanager.py,
	twisted/persisted/journal/base.py, twisted/persisted/dirdbm.py,
	twisted/scripts/conch.py, twisted/scripts/tapconvert.py,
	twisted/scripts/twistd.py, twisted/scripts/websetroot.py,
	twisted/test/test_mvc.py, twisted/test/test_persisted.py,
	twisted/web/woven/template.py, twisted/web/woven/view.py,
	twisted/popsicle/picklesicle.py: Change the usage of cPickle to
	fallback to pickle if the former is not available.

	* doc/howto/coding-standard.html: Document the way to use extension
	versions of modules for which there is a pure-python equivalent.

2003-04-26  Dave Peticolas  <dave@krondo.com>

	* twisted/enterprise/adbapi.py: commit successful _runQuery calls
	instead of rolling back

2003-04-23  Brian Warner  <warner@lothar.com>

	* doc/howto/telnet.html: Update example from twisted-0.15.5(!) to
	1.0.4

	* twisted/protocols/loopback.py: use reactor.iterate(0.01) so the
	tests hammer the CPU slightly less

	* twisted/test/test_trial.py (LoopbackTests.testError): .type is a
	string
	* twisted/trial/remote.py (JellyReporter.reportResults): stringify
	.type and .value from Failures before jellying them.

	* twisted/internet/base.py (ReactorBase.suggestThreadPoolSize):
	don't let suggestThreadPoolSize(0) be the only reason threads are
	initialized.

	* twisted/python/log.py (err): always log Failures to the logfile. If
	we're doing _keepErrors, then also add them to _keptErrors.

	* twisted/trial/unittest.py (TestSuite.runOneTest): only do
	reportResults once per test. Handle reactor.threadpool being None.

2003-04-22  Bob Ippolito <bob@redivi.com>

	* twisted/python/compat.py: Complete iter implementation with
	__getitem__ hack for 2.1.  dict now supports the full 2.3 featureset.

	* twisted/test/test_compat.py: Tests for compat module, so we know if
	it works or not now ;)

2003-04-22  Andrew Bennetts  <spiv@twistedmatrix.com>

	* twisted/lore/latex.py: Handle cross-references and labels slightly
	better, so that e.g. man/lore.html and howto/lore.html don't generate
	conflicting labels.  Also, emit \loreref{...} instead of \pageref{...}
	-- this isn't a standard LaTeX command, see admin/book.tex for an
	example definition.  In HTML generation, all relative hrefs in <a>
	tags are now munged from .html to .xhtml, unless class="absolute".

2003-04-21  Jp Calderone  <exarkun@twistedmatrix.com>

	* twisted/internet/interfaces.py: Added getServiceNamed, addService,
	and removeService to IServiceCollection.

2003-04-21  Brian Warner  <warner@lothar.com>

	* twisted/web/woven/*.py: add test-case-name tags

2003-04-21  Bob Ippolito <bob@redivi.com>

	* twisted/web/static.py (File, DirectoryListing): DirectoryListing
	now gets the directory listing from File.listNames, and no longer
	calls os.listdir directly (unless a directory listing is not
	specified in the DirectoryListing constructor).

2003-04-19  Brian Warner  <warner@lothar.com>

	* twisted/trial/remote.py (JellyReporter.cleanResults): handle
	strings as testClass/method to unbreak tests

	* twisted/trial/remote.py (JellyReporter.reportResults): send only
	name of testClass/method to remote reporter, not whole class and
	method. Also add .taster hook to DecodeReport to let users specify
	their own security options.

2003-04-17  Kevin Turner  <acapnotic@twistedmatrix.com>

	* .: Release 1.0.4 Final.

2003-04-16  Kevin Turner  <acapnotic@twistedmatrix.com>

	* .: Release 1.0.4rc1.

2003-04-15  Jp Calderone  <exarkun@twistedmatrix.com>

	* admin/accepttests, admin/accepttests.py: Acceptance tests
	turned into a Python module with no unguarded top-level code,
	to make running acceptance tests selectively possible.

2003-04-14  Brian Warner  <warner@lothar.com>

	* twisted/python/threadable.py (init):
	* twisted/spread/newjelly.py (SecurityOptions.allowBasicTypes):
	* twisted/spread/jelly.py (SecurityOptions.allowBasicTypes):
	Remove old apply() calls.

	* twisted/spread/flavors.py (Copyable.jellyFor): Use proper
	jellier .prepare/.preserve dance when .invoker is non-None. This
	fixes jellying of circular references when passed through PB
	connections.

	* twisted/test/test_newjelly.py: add test case that sets .invoker
	to verify that code path too

2003-04-14  Jonathan Lange  <jml@ids.org.au>

	* twisted/web/woven/controller.py (Controller): now, if getChild
	cannot find the requested child, it will ask getDynamicChild -- a
	method like getChild, but designed to be overriden by users.

2003-04-13  Bob Ippolito  <bob@redivi.com>

	* twisted/internet/app.py (DependentMultiService): a MultiService
	to start services in insert order and stop them in reverse.  Uses
	chained deferreds to ensure that if a startService or stopService
	returns a deferred, then the next service in the queue will wait
	until its dependency has finished.

2003-04-12  Brian Warner  <warner@lothar.com>

	* twisted/test/test_process.py (PosixProcessTestCasePTY): skip
	testStdio, testStderr, and testProcess. PTYs do not have separate
	stdout/stderr, so the tests just aren't relevant. testProcess
	might be, but it requires support for closing the write side
	separately from the read side, and I don't think our processPTY
	can do that quite yet.

	* twisted/test/test_tcp.py (LocalRemoteAddressTestCase): iterate
	harder. some systems might not connect to localhost before
	iterate() is called, flunking the test

	* twisted/test/test_process.py: only install SIGCHLD handler if the
	reactor offers a hook for it.

	* twisted/test/test_policies.py (ThrottlingTestCase.doIterations):
	add more iterations to accomodate reactors that do less IO per pass

	* twisted/test/process_signal.py: reset SIGHUP to default handler,
	fixes test failures in a 'nohup' environment

	* twisted/test/test_process.py (PosixProcessTestCasePTY): remove
	testClosePty.todo now that it works
	(SignalProtocol.processEnded): Improve testSignal error messages

	* twisted/internet/process.py (PTYProcess.connectionLost): Treat
	PTYs more like sockets: loseConnection sets .disconnecting and
	lets the write pipe drain, then the PTY is closed in
	connectionLost.

2003-04-12  Paul Swartz  <z3p@twistedmatrix.com>

	* twisted/plugins.tml, twisted/tap/ssh.py, twisted/tap/conch.py: moved
	the conch server from 'mktap ssh' to 'mktap conch'.

2003-04-12  Brian Warner  <warner@lothar.com>

	* twisted/internet/gtk2reactor.py (Gtk2Reactor.doIteration): don't
	process *all* events before exiting: lots of IO (like test cases which
	do connect()s from inside connectionMade) will keep us from surfacing
	from reactor.iterate(), causing a lockup.
	* twisted/internet/gtkreactor.py (GtkReactor.doIteration): same. Use
	the same code as gtk2reactor with minor gtk1-vs-gtk2 variations.

2003-04-11  Brian Warner  <warner@lothar.com>

	* twisted/internet/gtk2reactor.py (Gtk2Reactor.doIteration): use
	timers to match the behavior of select()-based reactors.
	reactor.iterate(delay) is thus defined to return after 'delay'
	seconds, or earlier if something woke it up (like IO, or timers
	expiring).

2003-04-11  Jp Calderone  <exarkun@twistedmatrix.com>

	* twisted/internet/defer.py: Added new, experimental function,
	"maybeDeferred".  API is subject to change.

2003-04-11  Jp Calderone  <exarkun@twistedmatrix.com>

	* twisted/scripts/mktap.py: Sped up --debug and --progress by
	introducing a two-pass option parser.

2003-04-11  Brian Warner  <warner@lothar.com>

	* twisted/internet/gtk2reactor.py: major fixes. Use different
	POLLIN/OUT flags to robustly work around pygtk bug, change
	callback() to behave more like pollreactor (since gtk uses poll
	internally). doIteration now calls gtk.main_iteration in a
	non-blocking way. Attempt to emulate doIteration(delay!=0) by
	using time.sleep().

	* twisted/internet/gtkreactor.py: same fixes as for gtk2reactor.
	Instead of a pygtk bug we've got the limited gtk_input_add API,
	which hides POLLHUP/POLLERR, so detecting closed fds might not be
	as reliable.

2003-04-11  Andrew Bennetts  <spiv@twistedmatrix.com>

	* twisted/lore:
	Added a "lore-slides" plugin, with HTML, Magicpoint and Prosper output
	targets.  It's still a bit rough, but functional.

2003-04-10  Kevin Turner  <acapnotic@twistedmatrix.com>

	* .: Release 1.0.4alpha2.

2003-04-09  Brian Warner  <warner@lothar.com>

	* twisted/scripts/trial.py (Options.opt_reactor): install reactor
	before parseArgs() does an import and installs the default one

	* twisted/internet/process.py: fix typo,
	s/registerReapProccessHandler/registerReapProcessHandler)/

2003-04-09  Jp Calderone <exarkun@twistedmatrix.com>

	* twisted/internet/base.py: Change the sort order of DelayedCalls
	and remove them from the end of the list instead of the beginning.
	This changes O(n) complexity to O(1) complexity.

2003-04-09  Brian Warner  <warner@lothar.com>

	* twisted/test/test_jelly.py, test_newjelly: Test cleanup.
	Parameterize the jelly module used by the tests, make test_jelly a
	subclass of test_newjelly using a different jelly module: tests
	should now be unified. Also change tests to use proper trial
	self.failUnless() methods instead of bare assert().

2003-04-09  Bob Ippolito  <bob@redivi.com>

	* twisted/python/util.py (OrderedDict): added a UserDict subclass
	that preserves insert order (for __repr__, items, values, keys).

	* twisted/internet/app.py (Application, _AbstractServiceCollection):
	Preserve service order, start services in order, stop them in reverse.

2003-04-09  Andrew Bennetts  <spiv@twistedmatrix.com>

	* twisted/protocols/ftp.py (FTPClient):
	Added STOR support to FTPClient, as well as support for using
	Producers or Consumers instead of Protocols for uploading/downloading.
	* twisted/protocols/policies.py (TimeoutWrapper):
	Added a timeout policy that can be used to automatically disconnect
	inactive connections.

2003-04-07  Brian Warner  <warner@lothar.com>

	* twisted/test/test_banana.py (BananaTestCase): add Acapnotic's
	crash-cBanana test case, and some others.

	* twisted/spread/banana.py (Pynana.dataReceived): add 640k limit on
	lists/tuples, parameterize the limit into banana.SIZE_LIMIT, define
	and use BananaError on all problems. Impose 640k limit on outbound
	lists/tuples/strings to catch problems on transmit side too.

	* twisted/spread/cBanana.c (cBanana_dataReceived): check malloc()
	return values to avoid segfault from oversized lists. Impose 640k
	limit on length of incoming lists. Raise BananaError on these
	checks instead of the previously-unreachable
	cBanana.'cBanana.error' exception.

	* twisted/test/test_process.py (TwoProcessProtocol): add test to make
	sure killing one process doesn't take out a second one
	(PosixProcessTestCasePTY): add variant that sets usePTY=1

2003-04-06  Brian Warner  <warner@lothar.com>

	* twisted/trial/{unittest.py,remote.py}, twisted/test/test_trial.py:
	Collapse most reportFoo methods into a single reportResults() that
	takes a resultType parameter. This anticipates the addition of .todo
	test-case flags that will add two more resultTypes.
	* twisted/trial/unittest.py: Add .todo flags: creates EXPECTED_FAILURE
	and UNEXPECTED_SUCCESS resultTypes. Like .skip, the .todo can be
	added either to the TestCase object or as a method attribute.

2003-04-04  Kevin Turner  <acapnotic@twistedmatrix.com>

	* twisted/scripts/trial.py: Now takes whatever you throw at it on
	the command line, be it a filename, or a dotted python name for a
	package, module, TestCase, or test method; you no longer need to
	use the -pmcfM switches (unless you really want to).

	* twisted/protocols/htb.py: Egress traffic shaping for Consumers
	and Transports, using Heirarchial Token Buckets, patterened after
	Martin Devera's Hierarchical Token Bucket traffic shaper for the
	Linux kernel.

	* doc/examples/shaper.py: Demonstration of shaping traffic on a
	web server.

	* twisted/protocols/pcp.py: Producer/Consumer proxy, for when you
	wish to install yourself between a Producer and a Consumer and
	subvert the flow of data.

2003-04-04  Itamar Shtull-Trauring  <itamar@itamarst.org>

	* twisted/web/microdom.py: parseXML and parseXMLString functions
	that are setup to use the correct settings for strict XML parsing
	and manipulation.

2003-03-31  Brian Warner  <warner@lothar.com>

	* twisted/trial/unittest.py: use SkipTest's argument as a reason
	and display it in the test results instead of the traceback. Allow
	test methods and TestCase classes to define a .skip attribute
	instead of raising SkipTest.

2003-03-31  Kevin Turner  <acapnotic@twistedmatrix.com>

	* twisted/trial/remote.py: machine-readable trial output to allow
	for the test runner and the results Reporter to be in seperate
	processes.

2003-03-15  Jp Calderone  <exarkun@twistedmatrix.com>

	* twisted/internet/app.py: Renamed "factory" argument to
	Application.listenUDP() to "proto"

2003-03-13  Tommi Virtanen  <tv@twistedmatrix.com>

	* twisted/tap/procmon.py, twisted/plugins.tml: support for mktapping
	ProcessMonitors.

2003-03-11  Bob Ippolito <bob@redivi.com>

	* twisted/internet/: Replaced apply() in non-deprecated
	twisted.internet modules with Direct Function Calls per
	recommendation from PEP 290.

	* twisted/web/client.py: HTTPPageGetter will now write
	self.factory.postdata to the transport after the headers if the
	attribute is present and is not None.  The factories, getPage and
	downloadPage now accept keyword arguments for method, postdata,
	and headers.  A Content-Length header will be automatically provided
	for the given postdata if one isn't already present.  Note that
	postdata is passed through raw; it is the user's responsibility to
	provide a Content-Type header and preformatted postdata.  This change
	should be backwards compatible.

2003-03-05  Itamar Shtull-Trauring  <itamar@itamarst.org>

	* twisted/internet/: reactor.run() now accepts a keyword
	argument, installSignalHandlers, indicating if signal handlers
	should be installed.

2003-03-04  Tommi Virtanen  <tv@twistedmatrix.com>

	* twisted/scripts/mktap.py, twisted/internet/app.py: mktap now
	accepts --uid=0 and --gid=0 to really mean root, has command line
	help for --uid=/--gid=, and understands user and group names in
	addition to numbers.

2003-03-04  Tommi Virtanen  <tv@twistedmatrix.com>

	* twisted/scripts/tap2deb.py, doc/man/tap2deb.1: Option --version=
	collided with global options, renamed to --set-version=.

2003-03-01  Jp Calderone  <exarkun@twistedmatrix.com>

	* twisted/scripts/twistd.py: Added --report-profile flag to twistd
	daemon.

2003-02-24  Brian Warner  <warner@lothar.com>

	* twisted/internet/tcp.py, base.py: set FD_CLOEXEC on all new
	sockets (if available), so they will be closed when spawnProcess
	does its fork-and-exec.

2003-02-23  Kevin Turner  <acapnotic@twistedmatrix.com>

	* twisted/scripts/manhole.py: 1.4 manhole now defaults to using a
	GTK2 client where available.  Start manhole with the "--toolkit gtk1"
	parameter if you want the old one back.

2003-2-19  Moshe Zadka <moshez@twistedmatrix.com>

	* twisted/web/monitor.py: Monitor web sites.

2003-2-20  Paul Swartz  <z3p@twistedmatrix.com>

	* twisted/internet/{app,default,interface,unix}.py: Add 'mode' argument
	to the listenUNIX interface, which sets the filesystem mode for the
	socket.

2003-2-18  Christopher Armstrong  <radix@twistedmatrix.com>

	* .: Release 1.0.4alpha1.

2003-2-18  Moshe Zadka <moshez@twistedmatrix.com>

	* twisted/web/server.py twisted/protocols/http.py: Add a way for
	resources (and other interested parties) to know when a request has
	finished, for normal or abnormal reasons.

2003-02-17  Paul Swartz  <z3p@twistedmatrix.com>

	* twisted/scripts/conch.py: Added experimental support for connection
	caching, where if a connection is already available to a server, the
	client will multiplex another session over the existing connection,
	rather that creating a new one.

2003-02-16  Jp Calderone  <exarkun@twistedmatrix.com>

	* doc/examples/echoserv.py: Rewrote main code to not create a .tap
	file (examples should be simple, and demonstrate as few things as
	possible each).

	* doc/examples/echoclient.py: Added UDP echo protocol
	implementation; it is unused by default, but easily enabled.

2003-02-16  Cory Dodt  <corydodt@yahoo.com>

	* twisted/lore/{latex,default}.py: provide a --config book option
	to Lore, for producing book-level documents from an index page.

2003-02-15  Jp Calderone  <exarkun@twistedmatrix.com>

	* twisted/scripts/mktap.py, twisted/scripts/twistd.py: Added the
	--appname and --originalname parameters, respectively.

	* twisted/doc/man/mktap.py, twisted/doc/man/twistd.py: Documented
	the above two new parameters.

2003-02-12  Kevin Turner  <acapnotic@twistedmatrix.com>

	* twisted/python/text.py (docstringLStrip): 1.6 This will be going
	away in favor of inspect.getdoc.

2003-02-11  Kevin Turner  <acapnotic@twistedmatrix.com>

	* twisted/im/interfaces.py (IAccount): 1.4 New instance attribute:
	"client".  Also, added methods getGroup and getPerson.

	* twisted/im/basechat.py (ChatUI.getPerson, .getGroup): 1.7 No
	longer accept a Class parameter.  The class of the person/group is
	determined by the account they are obtained through.

	* twisted/im/basesupport.py (AbstractPerson, AbstractGroup): 1.15
	Hold a reference to account, not client.  Also, lose the "chatui"
	parameter -- this may require follow-up.
	(AbstractAccount.__setstate__): 1.15 remove this method.  (Why
	was self.port = int(self.port) in __setstate__?)
	(AbstractAccount): 1.15 implement getGroup and getPerson here,
	using _groupFactory and _personFactory factory attributes.

	* twisted/im/gtkchat.py (GtkChatClientUI.getPerson, .getGroup): 1.15
	follow ChatUI interface changes.

2003-02-09  Brian Warner  <warner@lothar.com>

	* twisted/internet/error.py (ProcessDone,ProcessTerminated):
	* twisted/internet/process.py (Process.maybeCallProcessEnded,
	* twisted/internet/process.py (PTYProcess.maybeCallProcessEnded,
	record the signal that killed the process in .signal, set .signal
	to None if the process died of natural causes, set .exitCode to None
	if the process died of a signal.
	* twisted/test/test_process.py: verify .signal, .exitCode are set
	to None when they ought to be, verify signal-death is reported with
	ProcessTerminated and not ProcessDone

	* ChangeLog: Set add-log-time-format to iso8601.

2003-02-09  Christopher Armstrong  <radix@twistedmatrix.com>

	* .: Releasing 1.0.3rc1.

2003-02-08  Moshe Zadka <moshez@twistedmatrix.com>

	* twisted/tap/mail.py twisted/mail/tap.py twisted/plugins.tml:
	Moved from tap to mail, trying to thin down twisted.tap a little.

2003-02-07  Moshe Zadka <moshez@twistedmatrix.com>

	* twisted/lore/default.py twisted/lore/tree.py twisted/lore/latex.py
	twisted/lore/man2lore.py twisted/lore/math.py
	twisted/scripts/html2latex.py twisted/scripts/generatelore.py
	twisted/scripts/hlint.py twisted/scripts/lore.py bin/lore
	bin/generatelore bin/hlint bin/html2latex twisted/plugins.tml:
	refactor lore to be cleaner, more usable and more extendible.
	Removed old scripts, and combined them into one plugin-based script
	which supports Lore, Math-Lore and Man pages and converts to
	LaTeX, HTML and (man pages) to Lore.

2003-02-06  Bob Ippolito  <bob@redivi.com>

	* twisted/protocols/smtp.py: sendEmail supports multipartboundary
	keyword argument, which is useful for doing HTML emails if passed
	"alternative" as opposed to the default "mixed".  Uses 7bit
	encoding for mime types that start with 'text', base64 otherwise.

2003-02-04  Jp Calderone  <exarkun@twistedmatrix.com>

	* twisted/internet/app.py: listenUNIX and unlistenUNIX methods added
	to Application class.  These should be used in place of listenTCP
	and unlistenTCP when UNIX sockets are desired.  The old,
	undocumented behavior no longer works!  Also added connectUDP and
	unlistenUDP to Application.

2003-01-31  Cory Dodt  <corydodt@yahoo.com>

	* twisted/lore/latex.py:  Don't treat comments like text nodes, just
	  drop them.

2003-01-30  Jp Calderone  <exarkun@twistedmatrix.com>

	* twisted/internet/default.py
	  twisted/internet/base.py
	  twisted/internet/tcp.py
	  twisted/internet/ssl.py
	  twisted/internet/udp.py
	  twisted/internet/unix.py

	  Refactor of many internal classes, including Clients and
	Connectors.  UNIX socket functionality moved out of the TCP classes
	and into a new module, unix.py, and implementation of IReactorUNIX
	by PosixReactorBase made conditional on platform UNIX socket
	support.  Redundant inheritance cruft removed from various classes.

	* twisted/internet/app.py: listenWith, unlistenWith, and connectWith
	methods added to Application.

	* twisted/internet/interfaces.py: IReactorArbitrary added.

2003-01-30  Kevin Turner  <acapnotic@twistedmatrix.com>

	* twisted/manhole/service.py (IManholeClient.console): 1.35
	exception messages now use a Failure.
	(IManholeClient.listCapabilities): 1.35 Method to describe what
	capabilities a client has, i.e. "I can receive Failures for
	exceptions."

2003-01-29  Donovan Preston  <dp@twistedmatrix.com>

	* twisted/web/woven/controller.py
	  twisted/web/woven/template.py
	  twisted/web/woven/view.py
	  twisted/web/woven/widgets.py Major woven codepath cleanup

	* Uses a flat list of outstanding DOM nodes instead of
	recursion to keep track of where Woven is in the page
	rendering process

	* Removes View's dependency on DOMTemplate as a base
	class, in preparation for deprecation of DOMTemplate
	(all of the same semantics are now directly implemented
	in View). As a result, View has no base classes, making
	the inheritance chain cleaner.

	* Stores the namespace stacks (model, view, and controller
	name lookup chain) in the View directly, and each widget
	gets an immutable reference to it's position in the lookup
	chain when it is created, making re-rendering Widgets more
	reliable

	* Represents the namespace stacks as a cons-like tuple
	structure instead of mutable python lists, reducing
	confusion and list-copying; instead of copying the current
	stack lists each time a Widget is created, it just gets a
	reference to the current tuples for each of the stacks

2003-01-29  Christopher Armstrong  <radix@twistedmatrix.com>

	* .: Releasing 1.0.2 Final.

	* .: Releasing 1.0.3alpha1. Release Often :-D

2003-01-29  Kevin Turner  <acapnotic@twistedmatrix.com>

	* twisted/internet/abstract.py (FileDescriptor.__init__): 1.36
	Ephemeral.

	* twisted/internet/tcp.py (Port.__getstate__): 1.100 As an
	Ephemeral, this needs no __getstate__.

2003-01-27  Kevin Turner  <acapnotic@twistedmatrix.com>

	* twisted/spread/ui/gtk2util.py (login): Perspective Broker login
	dialog for GTK+ version 2.

2003-01-26  Christopher Armstrong  <radix@twistedmatrix.com>

	* .: Releasing 1.0.2rc1.

	* .: Releasing 1.0.2rc2 (rc1 was dead in the water; hlint bug now
	fixed).

	* .: Releasing 1.0.2rc3 (rc2 was dead in the water;
	twisted.lore.latex bug now fixed)

2003-01-26  Kevin Turner  <acapnotic@twistedmatrix.com>

	* twisted/im/interfaces.py (IClient.__init__): 1.3 Accept a
	logonDeferred parameter.  The client should call this back when
	it is successfully logged in.

	* twisted/im/basesupport.py
	(AbstractClientMixin.registerAsAccountClient): 1.13 Gone.
	chatui.registerAccountClient is called in AbstractAccount.logOn
	instead.

2003-01-22  Dave Peticolas  <dave@krondo.com>

	* twisted/web/xmlrpc.py: add docstring for Proxy. handle
	serialization errors. check for empty deferred on connectionLost.

	* twisted/test/test_internet.py: make sure wakeUp actually works

2003-01-21  Itamar Shtull-Trauring  <itamar@itamarst.org>

	* twisted/internet/defer.py: added utility method for
	getting result of list of Deferreds as simple list.

2003-1-20  Jp Calderone <exarkun@twistedmatrix.com>

	* twisted/internet/interfaces.py: type argument removed from
	IReactorCore.resolve method.  IReactorPluggableResolver interface
	added.

	* twisted/internet/base.py: IReactorPluggable added to
	ReactorBase.__implements__ and ReactorBase.installResolver added.

2003-1-18  Moshe Zadka <moshez@twistedmatrix.com>

	* twisted/trial/unittest.py twisted/scripts/trial.py: adding --summary

2003-01-15  Christopher Armstrong  <radix@twistedmatrix.com>

	* .: Releasing 1.0.2alpha3.

2003-01-13  Christopher Armstrong  <radix@twistedmatrix.com>

	* .: Releasing 1.0.2alpha2.

2003-01-11  Itamar Shtull-Trauring  <itamar@itamarst.org>

	* twisted/protocols/shoutcast.py: add client support for
	Shoutcast MP3 streaming protocol.

2003-01-10  Itamar Shtull-Trauring  <itamar@itamarst.org>

	* twisted/scripts/twistd.py: in debug mode, jump into debugger for any
	logged exception.

2003-01-10  Dave Peticolas  <dave@krondo.com>

	* twisted/trial/unittest.py: enable test cruft checking

	* twisted/test/test_policies.py: cleanup timers

	* twisted/protocols/policies.py: start/stop bandwidth timers as needed

	* twisted/test/test_internet.py: cleanup timers

	* twisted/test/test_woven.py: expire sessions to clean up timers

	* twisted/web/woven/guard.py: stop timer when session expires

2003-1-9  Moshe Zadka <moshez@twistedmatrix.com>

	* twisted/web/google.py: Search google for best matches

2003-01-09  Dave Peticolas  <dave@krondo.com>

	* twisted/protocols/http.py: start/stop log timer as needed

2003-01-08  Dave Peticolas  <dave@krondo.com>

	* twisted/test/test_smtp.py: cleanup timers after test

	* twisted/trial/unittest.py: keep errors that are logged and
	submit them as test failures when tests are finished.

	* twisted/python/log.py: if errors are being kept, don't print
	them

2003-1-8  Moshe Zadka <moshez@twistedmatrix.com>

	* doc/man/trial.1 twisted/scripts/trial.py: Add -l/--logfile argument
	to allow giving a log file.

	* twisted/trial/unittest.py: add SkipTest exception, which tests can
	raise in their various test* method to skip a test which is not
	excpected to pass.

2003-01-08  Jonathan M. Lange  <jml@mumak.net>

	* twisted/trial/*, bin/trial, twisted/scripts/trial.py,
	doc/man/trial.1: Added 'trial', a new unit testing framework for
	Twisted.

	* twisted/test/test_*, admin/runtests: Moved existing tests over to
	trial.

2003-01-06  Glyph Lefkowitz  <glyph@twistedmatrix.com>

	* twisted/python/microdom.py: Added beExtremelyLenient mode (for
	parsing "tag soup").  While this isn't quite as lenient as Mozilla
	or IE's code (it will, for example, translate
	<div><i><b>foo</i>bar</b></div> to <div><i><b>foo</b></i>bar</div>
	) I am still rather proud of the wide range of complete garbage
	that it will mangle into at least reasonably similar XHTML-esque
	documents.

2003-01-05  Brian Warner  <warner@lothar.com>

	* twisted/internet/cReactor/*, setup.py: Implement getDelayedCalls for
	cReactor. Create cDelayedCall class, implement .cancel(), .reset(),
	and .delay() for them.

2003-01-03  Jp Calderone  <exarkun@twistedmatrix.com>

	* twisted/python/components.py: Fix bug due to interaction between
	Componentized subclasses and twisted.python.rebuild.rebuild()

	* twisted/python/reflect.py: Removed backwards compatability hack
	for deprecated name twisted.protocols.telnet.ShellFactory and empty
	oldModules dictionary.

2003-01-02  Brian Warner  <warner@lothar.com>

	* twisted/test/test_internet.py (DelayedTestCase): add test
	coverage for IReactorTime.getDelayedCalls

2002-12-30  Brian Warner  <warner@lothar.com>

	* pyunit/unittest.py (TestCase.__call__): clean the reactor between
	tests: cancel any leftover reactor.callLater() timers. This helps
	to keep deferred failures isolated to the test that caused them.

2002-12-30  Paul Swartz  <z3p@twistedmatrix.com>

	* twisted/conch/*: added docstrings to most conch classes and functions

2002-12-30  Brian Warner  <warner@lothar.com>

	* twisted/spread/pb.py (Broker.connectionLost): clear localObjects
	too, to break a circular reference involving AuthServs that could
	keep the Broker (and any outstanding pb.Referenceables) alive
	forever.

2002-12-29  Jp Calderone  <exarkun@twistedmatrix.com>

	* twisted/python/compat.py: Single module where all compatability
	code for supporting old Python versions should be placed.

2002-12-28  Glyph Lefkowitz  <glyph@twistedmatrix.com>

	* twisted/web/woven/guard.py: Newer, better wrappers for
	authentication and session management.  In particular a nice
	feature of this new code is automatic negotiation with browsers on
	whether cookies are enabled or not.

2002-12-27  Paul Swartz <z3p@twistedmatrix.com>

	* bin/tkconch: initial commit of tkconch, a SSH client using Tkinter
	as a terminal emulator.  puts up a menu to configure when run without
	arguments.

	* twisted/conch/ui: moved ansi.py and tkvt100.py to t.c.ui so they are
	away from the purely conch stuff.

2002-12-25  Christmas Armstrong  <radix@twistedmatrix.com>

	* .: Releasing 1.0.2alpha1 - Merry Christmas!

2002-12-25  Jp Calderone  <exarkun@twistedmatrix.com>

	* twisted/protocols/dict.py: dict client protocol implementation
	from Pavel "Pahan" Pergamenshchik (<pp64@cornell.edu>)

2002-12-23  Jp Calderone  <exarkun@twistedmatrix.com>

	* doc/examples/testdns.py and doc/examples/dns-service.py added as
	simple example of how to use new DNS client API.

2002-12-23  Moshe Zadka <moshez@twistedmatrix.com>

	* twisted/web/xmlrpc.py:  added XML RPC client support

2002-12-22  Paul Swartz  <z3p@twistedmatrix.com>

	* twisted/conch/ssh/keys.py, twisted/conch/ssh/asn1.py: support for
	writing	public and private keys.

	* bin/ckeygen: new script to create public/private key pairs

2002-12-22  Jp Calderone  <exarkun@twistedmatrix.com>

	* twisted/protocols/dns.py: Support for AFSDB, RP, and SRV RRs
	added.

2002-12-18  Jp Calderone  <exarkun@twistedmatrix.com>

	* twisted/persisted/dirdbm.py: copyTo and clear methods added
	to DirDBM class

2002-12-18  Paul Swartz  <z3p@twistedmatrix.com>

	* twisted/conch/ssh/connection.py, twisted/test/test_conch: fixes to
	work on Python 2.1.

	* twisted/internet/process.py: usePTY now can be an optional tuple of
	(masterfd, slavefd, ttyname).

2002-12-18  Moshe Zadka <moshez@twistedmatrix.com>

	* twisted/web/rewrite.py: it works now, even when used as a rootish
	resource. Also, the request.path is massaged.

2002-12-13  Dave Peticolas  <dave@krondo.com>

	* twisted/enterprise/util.py: support numeric type

2002-12-13  Moshe Zadka <moshez@twistedmatrix.com>

	* twisted/web/client.py: add 301/302 support

2002-12-13  Dave Peticolas  <dave@krondo.com>

	* twisted/test/test_ftp.py: give client time to start up (fixes
	one test for gtk/gtk2 reactors)

	* twisted/protocols/ftp.py: ftp client in passive mode should not
	close data until both command and protocol are finished. (fixes
	one test in gtk/gtk2 reactors)

	* twisted/internet/gtkreactor.py: remove redundant code

	* twisted/internet/gtk2reactor.py: remove redundant code

	* twisted/internet/abstract.py: fix spelling in documentation

2002-12-12  Dave Peticolas  <dave@krondo.com>

	* twisted/test/test_jelly.py: test class serialization

	* twisted/spread/jelly.py: join module names with '.' in
	_unjelly_class

2002-12-12  Paul Swartz <z3p@twistedmatrix.com>

	* twisted/conch/pamauth.py: added, gives support for authentication
	using PAM.

	* twisted/conch/*: support for the keyboard-interactive authentication
	method which uses PAM.

2002-12-12  Moshe Zadka <moshez@twistedmatrix.com>

	* twisted/python/log.py: add setStdout, set logfile to NullFile by
	default.

2002-12-11  Donovan Preston <dp@twistedmatrix.com>

	* Added new woven example, Hello World.

	* Updated woven howto to talk about Hello World. TODO: Finish refactoring
	woven quotes example, then write more advanced woven howtos on writing
	Widgets and InputHandlers.

2002-12-11  Paul Swartz <z3p@twistedmatix.com>

	* twisted/conch/*: enabled 'exec' on the server, disabled core dumps,
	and some fixes

2002-12-10  Paul Swartz  <z3p@twistedmatrix.com>

	* twisted/conch/*: many fixes to conch server, now works and can run
	as root.

	* twisted/conh/ssh/session.py: fix root exploit where a python shell was
	left acessable to anyone.

2002-12-10  Cory Dodt  <corydodt@yahoo.com>

	* t/scripts/postinstall.py: new.  Create shortcut icons on win32.

	* twisted-post-install.py: new.  Runs t/scripts/postinstall.py

	* setup.py: copy twisted-post-install.py during install_scripts

2002-12-09  Paul Swartz  <z3p@twistedmatrix.com>

	* twisted/internet/app.py: actually set the euid/egid if users ask

2002-12-09  Dave Peticolas  <dave@krondo.com>

	* twisted/test/test_conch.py: wait for ssh process to finish

	* twisted/scripts/postinstall.py: fix indentation

	* twisted/conch/identity.py: fix indentation

2002-12-09  Paul Swartz  <z3p@twistedmatrix.com>

	* twisted/conch/ssh/transport.py: don't accept host keys by default
	because it's a huge security hole.

2002-12-09  Dave Peticolas  <dave@krondo.com>

	* twisted/enterprise/util.py: handle None as null

	* twisted/internet/interfaces.py: add missing 'self' argument

2002-12-08  Dave Peticolas  <dave@krondo.com>

	* pyunit/unittest.py: add missing 'self.' prefix to data member
	reference

	* twisted/enterprise/util.py: make sure quoted values are strings
	(fixes bug storing boolean types)

2002-12-06  Dave Peticolas  <dave@krondo.com>

	* twisted/test/test_internet.py: flush error to prevent failure
	with non-destructive DeferredLists.

	* twisted/test/test_ftp.py: flush FTPErrors to prevent failures
	with non-destructive DeferredLists.

	* twisted/test/test_defer.py: catch the errors to prevent failure
	with non-destructive DeferredLists

	* twisted/enterprise/util.py: add some postgres types. boolean
	types need to be quoted. remove unused selectSQL variable.

2002-12-05  Dave Peticolas  <dave@krondo.com>

	* twisted/enterprise/sqlreflector.py: fix some sql escaping
	bugs. allow subclasses to override escaping semantics.

	* twisted/enterprise/util.py: allow quote function's string escape
	routine to be overridden with a keyword argument.

2002-12-5  Moshe Zadka <moshez@twistedmatrix.com>

	* twisted/python/plugin.py: fixed a bug that got the wrong plugins.tml
	if the package was installed in two different places

	* twisted/inetd/*, twisted/runner/*: moved inetd to runner, to live in
	harmony with procmon

2002-12-04  Dave Peticolas  <dave@krondo.com>

	* twisted/test/test_policies.py: Take the start time timestamp
	immediately before creating the ThrottlingFactory, since the
	factory starts timing when it is created.

	* admin/runtests: Add a 'gtk2' test type to use the gtk2reactor
	for the test suite.

2002-12-2  Moshe Zadka <moshez@twistedmatrix.com>

	* twisted/web/client.py: web client

2002-11-30  Paul Swartz  <z3p@twistedmatrix.com>

	* Summary of Conch changes:  An actual client (bin/conch) which is
	mostly compatible with the OpenSSH client.  An optional C module to
	speed up some of the math operations.  A bunch of other stuff has
	changed too, but it's hard to summarize a month of work.

2002-11-24  Donovan Preston  <dp@twistedmatrix.com>

	* twisted/web/woven/*: Added the beginnings of a general framework for
	asynchronously updating portions of woven pages that have already been
	sent to the browser. Added controller.LiveController, page.LivePage,
	and utils.ILivePage to contain code for dealing with keeping Views alive
	for as long as the user is still looking at a page and has a live
	Session object on the server; code for responding to model changed
	notifications, rerendering Views that depend on those models that have
	changed; code for sending these rerendered views as html fragments to
	the browser; and javascript code to mutate the DOM of the live page
	with the updated HTML.  Mozilla only for the moment; ie to come soon.

	* twisted/web/woven/widgets.py: Added API for attaching Python functions
	to widgets that fire when a given javascript event occurs in the
	browser.
	Widget.addEventHandler(self, eventName, handler, *args) and
	Widget.onEvent(self, request, eventName, *args). The default onEvent
	will dispatch to event handlers registered with addEventHandler.

2002-11-24  Christopher Armstrong  <radix@twistedmatrix.com>

	* .: Releasing 1.0.1.

2002-11-23  Jp Calderone <exarkun@twistedmatrix.com>

	* twisted/names/client.py, twisted/names/server.py: Client and
	  server domain name APIs

	* twisted/tap/dns.py: 'mktap dns'

2002-11-23  Moshe Zadka <moshez@twistedmatrix.com>

	* twisted/scripts/twistd.py twisted/python/syslog.py: Add syslog support

2002-11-23  Kevin Turner  <acapnotic@twistedmatrix.com>, Sam Jordan  <sam@twistedmatrix.com>

	* twisted/protocols/irc.py (IRCClient.dccResume, dccAcceptResume):
	Methods for mIRC-style resumed file transfers.
	(IRCClient.dccDoSend, IRCClient.dccDoResume)
	(IRCClient.dccDoAcceptResume, IRCClient.dccDoChat): These are for
	clients to override to make DCC things happen.
	(IRCClient.dcc_SEND, dcc_ACCEPT, dcc_RESUME, dcc_CHAT)
	(IRCClient.ctcpQuery_DCC): Refactored to dispatch to dcc_* methods.
	(DccFileReceiveBasic.__init__): takes a resumeOffset

2002-11-20  Christopher Armstrong  <radix@twistedmatrix.com>

	* .: Releasing 1.0.1rc1

2002-11-16  Itamar Shtull-Trauring  <twisted@itamarst.org>

	* Multicast UDP socket support in most reactors.

2002-11-11  Glyph Lefkowitz  <glyph@twistedmatrix.com>

	* .: Releasing 1.0.1alpha4

	* .: Releasing 1.0.1alpha3

2002-11-10  Glyph Lefkowitz  <glyph@twistedmatrix.com>

	* .: Releasing 1.0.1alpha2

	* twisted/web/static.py, twisted/tap/web.py: Changed 'mktap web'
	to use --ignore-ext .ext so that you can assign order to the
	extensions you want to ignore, and not accidentally catch bad
	extensions.

2002-11-04  Itamar Shtull-Trauring  <twisted@itamarst.org>

	* twisted/internet/tksupport.py: new, better Tkinter integration.
	Unlike before, run the reactor as usual, do *not* call Tkinter's
	mainloop() yourself.

2002-10-25  Moshe Zadka <moshez@twistedmatrix.com>

	* twisted/web/domhelpers.py twisted/python/domhelpers.py
	twisted/lore/tree.py twisted/web/woven/widgets.py: Moved domhelpers
	to twisted.web, and add to it all the generic dom-query functions
	from twisted.lore.tree

	* twisted/scripts/generatelore.py twisted/scripts/html2latex.py
	bin/html2latex bin/generatelore twisted/lore/__init__.py
	twisted/lore/latex.py twisted/lore/tree.py: Add the document generation
	Twisted uses internally to the public interface.

	* twisted/python/htmlizer.py: a Python->HTML colouriser

2002-10-23  Itamar Shtull-Trauring  <twisted@itamarst.org>

	* twisted/web/soap.py: experimental SOAP support, using SOAPpy.
	See doc/examples/soap.py for sample usage.

2002-10-22  Christopher Armstrong  <radix@twistedmatrix.com>

	* twisted/python/log.py: Two new features.
	1) a stupid `debug' method that simply prefixes a message with "debug"
	and indents it so it's easier to distinguish from normal messages.
	This can eventually log to some magic "debug channel", once we have
	that implemented.

	2) implemented a custom warning handler; now warnings look sexy.
	(the hackish overriding of warnings.showwarning is the recommended way
	to do so, according to the library reference.)

2002-10-22  Moshe Zadka <moshez@twistedmatrix.com>

	* setup.py: conditionalize cReactor on threads support too. This
	is somewhat of a hack as it it done currently, but it's only necessary
	on weird OSes like NetBSD. I assume any UNIX with thread support has
	pthreads.

	* twisted/internet/tksupport.py: tunable reactor iterate delay
	parameter [by Jp Calderone]

2002-10-17  Moshe Zadka <moshez@twistedmatrix.com>

	* bin/websetroot twisted/scripts/websetroot.py: Added a program to set
	the root of a web server after the tap exists

2002-10-14  Moshe Zadka <moshez@twistedmatrix.com>

	* twisted/web/vhost.py: add a virtual host monster to support twisted
	sites behind a reverse proxy

	* twisted/tap/web.py twisted/web/script.py
	doc/man/mktap.1: adding an option to have a resource script as the root

2002-10-13  Moshe Zadka <moshez@twistedmatrix.com>

	* twisted/internet/utils.py twisted/internet/process.py
	twisted/internet/interfaces.py twisted/internet/default.py: Moved
	utility functions into twisted.internet.utils

2002-10-12  Moshe Zadka <moshez@twistedmatrix.com>

	* twisted/internet/process.py twisted/internet/interfaces.py
	twisted/internet/default.py: Add utility method to get output of
	programs.

2002-10-11  Itamar Shtull-Trauring  <itamarst@twistedmatrix.com>

	* twisted/internet/wxsupport.py: improved responsiveness of wxPython
	GUI (50 FPS instead of 10 FPS).

2002-10-08  Brian Warner  <warner@twistedmatrix.com>

	* doc/howto: Added PB/cred and Application docs, updated Manhole
	and Process docs. Moved Manhole from "Administrators" section to
	"Developers" section.

2002-10-10  Moshe Zadka <moshez@twistedmatrix.com>

	* .: Releasing 0.99.4

2002-10-07  Itamar Shtull-Trauring  <itamarst@twistedmatrix.com>

	* .: Release 0.99.4rc1

	* twisted/protocols/http.py: backed out changes to HTTP that
	broke 0.99.3 twisted.web.distrib.

2002-10-7  Moshe Zadka <moshez@twistedmatrix.com>

	* twisted/web/script.py: Add ResourceTemplate which uses PTL for
	creation of resources.

2002-10-7  Moshe Zadka <moshez@twistedmatrix.com>

	* twisted/tap/web.py: It is now possibly to add processors via
	the command line


2002-10-04  Itamar Shtull-Trauring  <itamarst@twistedmatrix.com>

	* twistd: when running in debug mode (-b), sending a SIGINT signal
	to the process will drop into the debugger prompt.

2002-10-5  Moshe Zadka <moshez@twistedmatrix.com>

	* .: Releasing 0.99.3

2002-10-01  Itamar Shtull-Trauring  <itamarst@twistedmatrix.com>

	* twisted/protocols/http.py: Fixed many bugs in protocol parsing,
	found by new unit tests.

2002-9-30  Moshe Zadka <moshez@twistedmatrix.com>

	* twisted/protocols/sux.py twisted/web/microdom.py: Made is possible
	to sanely handle parse errors

2002-09-26  Kevin Turner  <acapnotic@twistedmatrix.com>

	* twisted/internet/app.py (_AbstractServiceCollection.removeService):
	(MultiService.removeService): inverse of addService
	(ApplicationService.disownServiceParent): inverse of setServiceParent

2002-9-27  Moshe Zadka <moshez@twistedmatrix.com>

	* .: Releasing 0.99.2

2002-09-26  Glyph Lefkowitz  <glyph@twistedmatrix.com>

	* twisted/web/microdom.py: Better string formatting of XML
	elements is now available, to aid with debugging of web.woven
	(among other applications).

2002-09-25  Kevin Turner  <acapnotic@twistedmatrix.com>

	* twisted/tap/manhole.py: mktap manhole will now prompt for a
	password or accept one from stdin if one is not provided on the
	command line.

2002-09-25  Itamar Shtull-Trauring  <itamarst@twistedmatrix.com>

	* bin/tapconvert: made sure tapconvert program gets installed.

2002-09-24  Kevin Turner  <acapnotic@twistedmatrix.com>

	* twisted/web/resource.py (Resource.wasModifiedSince): revoked,
	not adding this after all.  Instead,

	* twisted/protocols/http.py (Request.setLastModified)
	(Request.setETag): these methods to set cache validation headers
	for the request will return http.CACHED if the request is
	conditional and this setting causes the condition to fail.

2002-9-24  Moshe Zadka <moshez@twistedmatrix.com>

	* .: Releasing 0.99.2rc2

2002-9-23  Donovan Preston <dp@twistedmatrix.com>

	* Renaming domtemplate/domwidgets/dominput/wmvc to Woven
	Woven - The Web Object Visualization Environment

	* Created package twisted/web/woven

	* Renamed domtemplate to template, domwidgets to widgets,
	and dominput to input

	* Refactored wmvc into three modules, model, view, and controller

2002-9-23  Moshe Zadka <moshez@twistedmatrix.com>

	* twisted/spread/pb.py: add getObjectAtSSL, refactored into
	getObjectRetreiver so more transports can be easily supported

2002-09-21  Kevin Turner  <acapnotic@twistedmatrix.com>

	* twisted/protocols/http.py (Request.setLastModified): Use
	setLastModified to set a timestamp on a http.Request object, and
	it will add a Last-Modified header to the outgoing reply.

	* twisted/web/resource.py (Resource.wasModifiedSince): companion
	method, override this to get sensible handling of
	If-Modified-Since conditional requests.

2002-09-21  Glyph Lefkowitz  <glyph@twistedmatrix.com>

	* twisted/web/static.py, twisted/web/script.py: Previously, it was
	  not possible to use the same xmlmvc application (directory full
	  of files and all) to interface to separate instances in the same
	  server, without a considerable amount of hassle.  We have
	  introduced a new "Registry" object which is passed to all .rpy
	  and .epy scripts as "registry" in the namespace.  This is a
	  componentized, so it can be used to associate different
	  components for the same interface for different File instances
	  which represent the same underlying directory.

2002-09-20  Glyph Lefkowitz  <glyph@twistedmatrix.com>

	* twisted/web/microdom.py: You can now specify tags that the
	  parser will automatically close if they are not closed
	  immediately.  This is to support output from HTML editors which
	  will not output XML, but still have a predictable
	  almost-but-not-quite XML structure.  Specifically it has been
	  tested with Mozilla Composer.

2002-9-20  Moshe Zadka <moshez@twistedmatrix.com>

	* Documenting for others

	* setup.py: now setup.py can function as a module

	* twisted/enterprise/xmlreflector.py: deprintified

	* twisted/internet/abstract.py, twisted/internet/fdesc.py,
	  twisted/internet/app.py, twisted/internet/gtkreactor.py,
	  twisted/internet/main.py, twisted/internet/protocol.py,
	  twisted/internet/ssl.py, twisted/internet/tksupport.py,
	  twisted/internet/pollreactor.py, twisted/internet/defer.py:
	  added and modified __all__

	* twisted/internet/base.py: changed ReactorBase's __name__, added
	__all__

	* twisted/internet/default.py, twisted/internet/error.py,
	  twisted/internet/process.py,
	  twisted/internet/win32eventreactor.py: reaping all processes on
	  SIGCHLD, changes in process's API

	* twisted/python/components.py: added Adapter and setComponent

	* twisted/python/log.py: logging several strings works

	* twisted/python/reflect.py: fixed namedModule() to handle packages

	* twisted/web/dom*.py: added submodels, moved to microdom, removed
	unsafe code

	* twisted/python/mvc.py: changed submodel support, added ListModel,
	Wrapper

	* twisted/web/microdom.py: minidom compat fixes

2002-9-20  Jp Calderone <exarkun@twistedmatrix.com>

	* twisted/internet/error.py twisted/internet/process.py:
	ProcessEnded -> ProcessTerminated/ProcessDone. Now it is possible
	to read off the error code.

2002-9-19  Moshe Zadka <moshez@twistedmatrix.com>

	* twisted/scripts/twistd.py: Added ability to chroot. Moved directory
	change to after loading of application.

2002-9-19  Moshe Zadka <moshez@twistedmatrix.com>

	* twisted/*: changed print to log.msg

	* bin/* twisted/scripts/*.py: move code from bin/ to modules

	* twisted/inetd/*.py: inetd server in twisted

	* twisted/protocols/sux.py twisted/web/microdom.py: XML parsing

	* twisted/conch/*.py: better logging and protocol support

	* twisted/cred/*.py: deprecation fixes

	* twisted/internet/app.py: add encryption

	* twisted/internet/base.py: fix deprecation, add DelayedCall,
	move to connect*  from client*

	* twisted/internet/error.py: errno mapping works on more platforms,
	AlreadyCalled, AlreadyCancelled errors

	* twisted/internet/gtkreactor.py: try requiring gtk1.2, timeout->idle

	* twisted/internet/interfaces.py: added IDelayedCall IProcessTransports

	* twisted/internet/javareactor.py: using failure, better dealing with
	connection losing, new connect* API

	* twisted/internet/process.py: dealing better with ending

	* twisted/internet/protocol.py: factories have a "noisy" attribute,
	added ReconnectingClientFactory BaseProtocol

	* twisted/internet/ptypro.py: fixed traceback

	* twisted/internet/reactor.py: better guessing of default

	* twisted/internet/tcp.py: failure

	* twisted/internet/win32eventreactor.py: update to new API, support GUI

	* twisted/manhole/service.py: fix deprecation

	* twisted/news/database.py: fix to be 2.1 compat., generating
	message-id, bytes, lines, date headers, improved storage

	* twisted/news/news.py: UsenetClientFactory, UsenetServerFactory

	* twisted/persisted/marmalade.py: use twisted.web.microdom

	* twisted/protocols/ftp.py: dito, data port uses new client API

	* twisted/protocols/http.py: StringTransport instead of StringIO

	* twisted/protocols/irc.py: stricter parsing, avoid flooding

	* twisted/protocols/loopback.py: new reactor API, loopback over UNIX
	sockets

	* twisted/protocols/nntp.py: more lenient parsing, more protocol support

	* twisted/protocols/oscar.py: new reactor API

	* twisted/python/components.py: fix setAdapter add removeComponent

	* twisted/python/failure.py: cleanFailure

	* twisted/python/log.py: can now log multiple strings in one go

	* twisted/python/logfile.py: fixed rotation

	* twisted/python/rebuild.py: better 2.2 support

	* twisted/python/util.py: getPassword

	* twisted/scripts/mktap.py: better --help, --type, encryption

	* twisted/spread/*.py: removed deprecation warnings

	* twisted/spread/util.py: improved Pager

	* twisted/tap/news.py: works saner now

	* twisted/tap/ssh.py: can specify authorizer

	* twisted/tap/words.py: can bind services to specific interfaces

	* twisted/web/distrib.py: now works on java too

	* twisted/web/domtemplate.py: improved cache

	* twisted/web/error.py: ForbiddenResource

	* twisted/web/html.py: lower-case tags

	* twisted/web/server.py: use components

	* twisted/web/static.py: added .flac, .ogg, properly 404/403,
	lower-case tags

	* twisted/web/twcgi.py: fixed for new process API

	* twisted/web/widgets.py: lower-case tags

	* twisted/web/xmlrpc.py: new abstraction for long running xml-rpc
	commands, add __all__

	* twisted/words/ircservice.py: new connectionLost API

	* twisted/words/service.py: refactoring and error handling

	* twisted/words/tendril.py: lots of fixes, it works now

2002-09-17  Donovan Preston  <dp@twistedmatrix.com>

	* Added better error reporting to WebMVC. To do this, I had to
	remove the use of "class" and "id" attributes on nodes as
	synonyms for "model", "view", and "controller". Overloading
	these attributes for three purposes, not to mention their
	usage by JavaScript and CSS, was just far too error-prone.

2002-09-09  Andrew Bennetts  <spiv@twistedmatrix.com>

	* twisted.inetd: An inetd(8) replacement.  TCP support should be
	complete, but UDP and Sun-RPC support is still buggy.  This was
	mainly written as a proof-of-concept for how to do a forking
	super-server with Twisted, but is already usable.

2002-08-30  Christopher Armstrong  <radix@twistedmatrix.com>

	* Releasing Twisted 0.99.1rc4. There was a bug in the acquisition
	code, as well as a typo in TwistedQuotes.

2002-08-29  Christopher Armstrong  <radix@twistedmatrix.com>

	* Releasing Twisted 0.99.1rc3. A bug in the release script
	left .pyc files in the tarball.

2002-08-29  Christopher Armstrong  <radix@twistedmatrix.com>

	* Releasing Twisted 0.99.1rc2. There was a bug with circular
	imports between modules in twisted.python.

2002-08-28  Christopher Armstrong  <radix@twistedmatrix.com>

	* Releasing Twisted 0.99.1rc1.

2002-08-27  Donovan Preston  <dp@twistedmatrix.com>

	* twisted.web.domtemplate: Look up templates in the directory of
	the module containing the DOMTemplate doing the lookup before
	going along with regular acquisition.

2002-08-27  Glyph Lefkowitz  <glyph@twistedmatrix.com>

	* twisted.*: Lots of minor fixes to make JavaReactor work again.

2002-08-26  Andrew Bennetts  <andrew-twisted@puzzling.org>

	* twisted.python.logfile: Added the ability to disable log
	rotation if logRotation is None.

2002-08-22  Jp Calderone  <exarkun@twistedmatrix.com>

	* twisted.news: Added a decent RDBM storage backend.

2002-08-21  Paul Swartz  <z3p@twistedmatrix.com>

	* doc/howto/process.html: Process documentation, too!

2002-08-20  Paul Swartz  <z3p@twistedmatrix.com>

	* doc/howto/clients.html: Client-writing documentation.

2002-08-20  Jp Calderone  <exarkun@twistedmatrix.com>

	* twisted.protocols.nntp: More protocol implemented: SLAVE, XPATH,
	XINDEX, XROVER, TAKETHIS, and CHECK.

2002-08-19  Christopher Armstrong  <radix@twistedmatrix.com>

	* bin, twisted.scripts.*: Migrated all bin/* scripts'
	implementations to twisted/scripts. This means win32 users will
	finally have access to all of the twisted scripts through .bat
	files!

2002-08-19  Jp Calderone  <exarkun@twistedmatrix.com>

	* twisted.news, twisted.protocols.nntp: Additional RFC977 support:
	HELP and IHAVE implemented.

2002-08-19  Itamar Shtull-Trauring  <itamarst@twistedmatrix.com>

	* twisted.internet.{process,win32eventreactor,etc}: New and
	hopefully final Process API, and improved Win32 GUI support.

2002-08-18  Christopher Armstrong  <radix@twistedmatrix.com>

	* Everything: Got rid of almost all usage of the `print' statement
	as well as any usage of stdout. This will make it easier to
	redirect boring log output and still write to stdout in your
	scripts.

2002-08-18  Christopher Armstrong  <radix@twistedmatrix.com>

	* Releasing Twisted 0.99.0 final. No changes since rc9.

2002-08-17  Christopher Armstrong  <radix@twistedmatrix.com>

	* Releasing Twisted 0.99.0rc8, with a fix to tap2deb and
	slightly updated options documentation.

	* Releasing Twisted 0.99.0rc9 with fixes to release-twisted
	and doc/howto/options.html.

2002-08-16  Christopher Armstrong  <radix@twistedmatrix.com>

	* Releasing Twisted 0.99.0rc6, with some fixes to setup.py
	* Releasing Twisted 0.99.0rc7, __init__.py fixes.

2002-08-15  Christopher Armstrong  <radix@twistedmatrix.com>

	* Releasing Twisted 0.99.0rc5, with some one severe bug-fix and
	a few smaller ones.

2002-08-14  Christopher Armstrong  <radix@twistedmatrix.com>

	* Releasing Twisted 0.99.0rc1! ON THE WAY TO 1.0, BABY!
	* Releasing Twisted 0.99.0rc2! Sorry, typoed the version number in
	copyright.py
	* Releasing Twisted 0.99.0rc3! I HATE TAGGING!
	* Releasing Twisted 0.99.0rc4, some very minor errors fixed.

2002-08-14  Glyph Lefkowitz  <glyph@twistedmatrix.com>

	* twisted.internet, twisted.cred: Applications and Authorizers are
	now completely decoupled, save for a tiny backwards-compatibility.

2002-08-10  Christopher Armstrong  <radix@twistedmatrix.com>

	* twisted.internet.defer, twisted.python.failure: Changes to
	Deferred and Failure to make errbacks more consistent. error
	callbacks are now *guaranteed* to be passed a Failure instance,
	no matter what was passed to Deferred.errback().

2002-08-07  Jp Calderone  <exarkun@twistedmatrix.com>

	* twisted.python.usage: New "subcommands" feature for
	usage.Options: Now, you can have nested commands
	(`cvs commit'-style) for your usage.Options programs.

2002-08-04  Bruce Mitchener  <bruce@twistedmatrix.com>

	* twisted.internet: New `writeSequence' method on transport
	objects: This can increase efficiency as compared to `write`ing
	concatenated strings, by copying less data in memory.

2002-08-02  Glyph Lefkowitz  <glyph@twistedmatrix.com>

	* twisted.cred.service, twisted.internet.app: Application/Service
	refactor: These two things should be less dependant on each other,
	now.

2002-07-31  Glyph Lefkowitz  <glyph@twistedmatrix.com>

	* twisted.issues: After weeks of hacking in the secret (Austin,
	TX) hideout with Allen Short, twisted.issues, the successor to
	Twisted Bugs, is born. Featuring a paranoia-inducing chat-bot
	interface!

2002-07-30  Itamar Shtull-Trauring  <itamarst@twistedmatrix.com>

	* twisted.internet.kqueue: Thanks to Matt Campbell, we now have a
	new FreeBSD KQueue Reactor.

2002-07-27  Christopher Armstrong  <radix@twistedmatrix.com>

	* doc/fun/Twisted.Quotes: Added our seekrut Twisted.Quotes file to
	Twisted proper.

2002-07-26  Glyph Lefkowitz  <glyph@twistedmatrix.com>

	* twisted.spread: "Paging" for PB: this is an abstraction for
	sending big streams of data across a PB connection.


2002-07-23  Itamar Shtull-Trauring  <itamarst@twistedmatrix.com>

	* twisted.internet: Rewrite of client APIs. `reactor.clientXXX'
	methods are now deprecated. See new reactor.connect*
	documentation. Also Application-level client methods have been
	reworked, see the Application documentation.

2002-07-23  Bryce Wilcox-O'Hearn  <zooko@twistedmatrix.com>

	* twisted.zoot: Application-level implementation of Gnutella.

2002-07-21  Glyph Lefkowitz  <glyph@twistedmatrix.com>

	* twisted.im, bin/im: GUI improvements to t-im, and renamed
	bin/t-im to bin/im (and get rid of old twisted.words client).

2002-07-15  Bryce Wilcox-O'Hearn  <zooko@twistedmatrix.com>

	* twisted.protocols.gnutella: Twisted now has an implementation of
	the Gnutella protocol.

2002-07-15  Sean Riley  <sean@twistedmatrix.com>

	* twisted.sister: Now featuring distributed login.

2002-07-15  Paul Swartz  <z3p@twistedmatrix.com>

	* twisted.conch: A new implementation of ssh2, bringing Twisted
	one step closer to being a complete replacement of all unix
	services ;-)

2002-07-14  Christopher Armstrong  <radix@twistedmatrix.com>

	* Releasing Twisted 0.19.0! It's exactly the same as rc4.

2002-07-13  Christopher Armstrong  <radix@twistedmatrix.com>

	* Releasing Twisted 0.19.0rc4. All Known Issues in the README have
	been fixed. This will hopefully be the last release candidate for
	0.19.0.

2002-07-07  Christopher Armstrong  <radix@twistedmatrix.com>

	* Releasing Twisted 0.19.0rc3.

2002-07-07  Christopher Armstrong  <radix@twistedmatrix.com>

	* Releasing Twisted 0.19.0rc2.

2002-07-07  Christopher Armstrong  <radix@twistedmatrix.com>

	* Releasing Twisted 0.19.0rc1.

2002-07-07  Keith Zaback  <krz@twistedmatrix.com>

	* twisted.internet.cReactor: A new poll-based reactor written in
	C. This is still very experimental and incomplete.

2002-07-07  Donovan Preston  <dp@twistedmatrix.com>

	* twisted.web.dom*: Better support in domtemplate/domwidgets etc
	for Deferreds and Widgets. Also deprecated getTemplateMethods
	method in favor of automatically looking up methods on the class
	based on the attributes found in the template. There are some
	minimal docs already, and better ones coming soon.

2002-06-26  Glyph Lefkowitz  <glyph@twistedmatrix.com>

	* twisted.internet.process,interfaces,default: Process now
	supports SetUID: there are new UID/GID arguments to the process
	spawning methods/constructors.

2002-06-22  Paul Swartz  <z3p@twistedmatrix.com>

	* twisted.protocols.oscar: totally rewrote OSCAR protocol
	implementation.

2002-06-18  Glyph Lefkowitz  <glyph@twistedmatrix.com>

	* twisted.internet.defer: Deprecated the arm method of Deferred
	objects: the replacement is a pair of methods, pause and
	unpause. After the pause method is called, it is guaranteed that
	no call/errbacks will be called (at least) until unpause is
	called.

2002-06-10  Christopher Armstrong  <radix@twistedmatrix.com>

	* twisted/persisted/aot.py, bin/twistd,mktap, twisted/internet/app.py:

	AOT (Abstract Object Tree) experimental source-persistence
	mechanism. This is a more-concise, easier-to-edit alternative to
	Twisted's XML persistence, for people who know how to edit Python
	code. Also added appropriate options to mktap and twistd to
	load/save .tas (Twisted Application Source) files.

	I will be working on making the formatting better, soon, but it's
	workable for now.

2002-06-08  Glyph Lefkowitz  <glyph@twistedmatrix.com>

	* twisted.internet, twisted.tap.web: Add a --https and related
	options to 'mktap web'; web is now much more SSL-friendly.


2002-06-02  Itamar Shtull-Trauring  <twisted@itamarst.org>

	* twisted.internet: changed protocol factory interface - it now has
	doStop and doStart which are called in reactors, not app.Application.
	This turns start/stopFactory into an implementation-specific feature,
	and also ensures they are only called once.

2002-06-01  Christopher Armstrong  <radix@twistedmatrix.com>

	* .: Releasing Twisted 0.18.0

2002-05-31  Christopher Armstrong  <radix@twistedmatrix.com>

	* twisted/coil/plugins/portforward.py, twisted/tap/portforward.py:
	  Forgot to add these before rc1 :-) You can use the portforwarder
	  with Coil and mktap again (previously "stupidproxy")

	* twisted/web/static.py: Fixed a bunch of bugs related to redirection
	for directories.

	* .: Releasing Twisted 0.18.0rc2

2002-05-30  Glyph Lefkowitz  <glyph@twistedmatrix.com>

	* Twisted no longer barfs when the Python XML packages aren't available.

2002-05-29  Christopher Armstrong  <radix@twistedmatrix.com>

	* .: Releasing Twisted 0.18.0rc1

2002-05-25  Christopher Armstrong  <radix@twistedmatrix.com>

	* twisted/spread/pb.py, twisted/internet/defer.py,
	  twisted/python/failure.py, etc:

	  Perspective broker now supports Failures! This should make writing
	  robust PB clients *much* easier. What this means is that errbacks will
	  recieve instances of t.python.failure.Failure instead of just strings
	  containing the traceback -- so you can easily .trap() particular
	  errors and handle them appropriately.

2002-05-24  Itamar Shtull-Trauring, Moshe Zadka <moshez@twistedmatrix.com>

	* twisted.mail cleanups:

		* basic bounce support.

		* removed telnet from mail tap

		* mail domains now receive service in __init__

		* split file system stuff into Queue (renamed from
	          MessageCollection)

		* Put a Queue in service

	* twisted/protocol/smtp.py: changed SMTPClient API so that it returns
	a file for the message content, instead of a string.

2002-05-23  Glyph Lefkowitz  <glyph@twistedmatrix.com>

	* Twisted applications can now be persisted to XML files (.tax) with
	the --xml option -- this is pretty verbose and needs some optimizations.

2002-05-22  Glyph Lefkowitz  <glyph@twistedmatrix.com>

	* twisted/persisted/marmalade.py: Marmalade: Jelly, with just a hint
	of bitterness. An XML object serialization module designed so
	people can hand-edit persisted objects (like Twisted Applications).

2002-05-21  Itamar Shtull-Trauring  <twisted@itamarst.org>

	* twisted/internet/gtkreactor.py: GTK+ support for win32; input_add
	is not supported in win32 and had to be worked around.

2002-05-20  Itamar Shtull-Trauring  <twisted@itamarst.org>

	* twisted/pythor/defer.py, twisted/protocols/protocol.py,
	  twisted/internet/defer.py, twisted/internet/protocol.py:

	    Moved defer and protocol to twisted.internet to straighten
	    out dependancies.

2002-05-18  Glyph Lefkowitz  <glyph@twistedmatrix.com>

	* twisted/metrics, twisted/forum: Metrics and Forum are no longer
	a part of Twisted proper; They are now in different CVS modules, and
	will be released separately.

2002-05-15  Andrew Bennetts <andrew-twisted@puzzling.org>

	* twisted/protocols/ftp.py: Small fixes to FTPClient that have
	changed the interface slightly -- return values from callbacks
	are now consistent for active and passive FTP.  Have a look at
	doc/examples/ftpclient.py for details.

2002-05-12  Itamar Shtull-Trauring  <twisted@itamarst.org>

	* doc/specifications/banana.html: Documentation of the Banana protocol.

2002-05-06  Glyph Lefkowitz  <glyph@twistedmatrix.com>

	* twisted/im/gtkchat.py: Some more UI improvements to InstanceMessenger:
	Nicks are now colorful (each nick is hashed to get a color) and
	messages now have timestamps.

2002-05-04  Glyph Lefkowitz  <glyph@twistedmatrix.com>

	* Reactor Refactor! Pretty much all of the twisted.internet.* classes
	are being depracated in favor of a single, central class called the
	"reactor". Interfaces are defined in twisted.internet.interfaces.
	For a much more descriptive comment about this change, see
	http://twistedmatrix.com/pipermail/twisted-commits/2002-May/002104.html.

2002-05-04  Glyph Lefkowitz  <glyph@twistedmatrix.com>

	* twisted/spread/pb.py: There is now some resource limiting in PB.
	Clients can now have the number of references to an object limited.

2002-04-29  Glyph Lefkowitz  <glyph@twistedmatrix.com>

	* twisted/im/*: Refactored Twisted InstanceMessenger to seperate GUI
	and logic. Also improved the UI a bit.

2002-04-28  Itamar Shtull-Trauring  <twisted@itamarst.org>

	* twisted/protocols/http.py: log hits using extended log format
	and make web taps logfile configurable.

2002-04-26  Itamar Shtull-Trauring  <twisted@itamarst.org>

	* twisted/lumberjack/logfile.py: reversed order of rotated
	logs - higer numbers are now older.

2002-04-24  Itamar Shtull-Trauring  <twisted@itamarst.org>

	* doc/examples/ircLogBot.py: We now have a sample IRC bot that logs
	all messages to a file.

2002-04-24  Itamar Shtull-Trauring  <twisted@itamarst.org>

	* twisted/python/components.py: Twisted's interfaces are now
	more like Zope's - __implements__ is an Interface subclass
	or a tuple (or tuple of tuples). Additonally, an instance can
	implement an interface even if its class doesn't have an
	__implements__.

2002-04-22  Glyph Lefkowitz  <glyph@twistedmatrix.com>

	* twisted/python/usage.py: Minor niceties for usage.Options:
	You can now look up the options of an Options object with
	optObj['optName'], and you if you define opt_* methods with
	underscores in them, using dashes on the command line will work.

2002-04-21  Chris Armstrong  <carmstro@twistedmatrix.com>

	* twisted/scripts/mktap.py: No more --manhole* options, use
	'--append=my.tap manhole' now.

2002-04-20  Chris Armstrong  <carmstro@twistedmatrix.com>

	* .: Releasing Twisted 0.17.4.

	* twisted/internet/tcp.py: Make unix domain sockets *really*
	world-accessible, rather than just accessible by "other".

2002-04-19  Itamar Shtull-Trauring  <itamarst@twistedmatrix.com>

	* twisted/web/{server,twcgi}.py: Fixed POST bug in distributed
	web servers.

2002-04-19  Chris Armstrong  <carmstro@twistedmatrix.com>

	* .: Releasing Twisted 0.17.3.

2002-04-19  Glyph Lefkowitz  <carmstro@twistedmatrix.com>

	* twisted/web/distrib.py: Fix a bug where static.File transfers
	over a distributed-web connection would not finish up properly.

2002-04-18  Chris Armstrong  <carmstro@twistedmatrix.com>

	* .: Releasing Twisted 0.17.2.

2002-04-18  Chris Armstrong  <carmstro@twistedmatrix.com>

	* twisted/news: A news server and NNTP protocol support courtesy of
	exarkun. Another step towards Twisted implementations of EVERYTHING
	IN THE WORLD!

2002-04-17  Glyph Lefkowitz  <glyph@twistedmatrix.com>

	* twisted/spread/pb.py: Errors during jelly serialization used to
	just blow up; now they more properly return a Deferred Failure. This
	will make hangs in PB apps (most notably distributed web) less common.

2002-04-17  Donovan Preston <dp@twistedmatrix.com>

	* Major changes to the capabilities of the static web server, in an
	attempt to be able to use Twisted instead of Zope at work; my plan is to
	capture many of the conveniences of Zope without the implicitness and
	complexity that comes with working around implicit behavior when it fails.

	1) .trp and .rpy support in the static web server:
	Very simple handlers to allow you to easily add Resource objects
		dynamically to a running server, by merely changing files on the
		filesystem.
	An .rpy file will be executed, and if a "resource" variable exists upon the
		execution's completion, it will be returned.
	A .trp file (twisted resource pickle) will be unpickled and returned. An
		object unpickled from a .trp should either implement IResource itself,
		or have a registered adapter in twisted.python.components.

	2) Acquisition:
	As resources are being looked up by repeated calls to getChild, this
		change creates instances of
		twisted.spread.refpath.PathReferenceAcquisitionContext and puts
		them in the request as "request.pathRef"
	Any method that has an instance of the request can then climb up
		the parent tree using "request.pathRef['parentRef']['parentRef']
	PathReferenceAcquisitionContext instances can be dereferenced to the
		actual object using getObject
	Convenience method: "locate"   returns a PathReference to first place
		in the parent heirarchy a name is seen
	Convenience method: "acquire"  somewhat like Zope acquisition;
		mostly untested, may need fixes

	3) DOM-based templating system:
	A new templating system that allows python scripts to use the DOM
		to manipulate the HTML node tree. Loosely based on Enhydra.
	Subclasses of twisted.web.domtemplate.DOMTemplate can override
		the templateFile attribute and the getTemplateMethods method;
		ultimately, while templateFile is being parsed, the methods
		specified will be called with instances of xml.dom.mindom.Node
		as the first parameter, allowing the python code to manipulate
		(see twisted.web.blog for an example)

2002-04-17  Chris Armstrong  <carmstro@twistedmatrix.com>

	* twisted/web/static.py, twisted/tap/web.py: Added a new feature
	that allows requests for /foo to return /foo.extension, which is
	disabled by default. If you want a --static webserver that
	uses this feature, use 'mktap web --static <dir> --allow_ignore_ext'.

	* twisted/tap/web.py: Also switched --static to --path; it doesn't
	make sense to call something that automatically executes cgis, epys,
	rpys, php, etc., "static". :-)

2002-04-14  Itamar Shtull-Trauring  <itamarst@twistedmatrix.com>

	* HTTP 1.1 now supports persistent and pipelined connections.

	User-visible API changes:
	- Request.content is now a file-like object, instead of a string.
	- Functions that incorrectly used Request.received instead of
	  Request.getAllHeaders() will break.
	- sendHeader, finishHeaders, sendStatus are all hidden now.

2002-04-12  Kevin Turner  <acapnotic@twistedmatrix.com>

	* twisted/coil/plugins/tendril.py (TendrilConfigurator): New coil
	configurator for words.tendril.

2002-04-10  Chris Armstrong  <carmstro@twistedmatrix.com>

	* .: Releasing Twisted 0.17.0

2002-04-10  Chris Armstrong  <carmstro@twistedmatrix.com>

	* twisted/bugs: Gone. Separate plugin package.
	* twisted/eco: Gone. The king is dead. Long live the king!
	(eco is no longer going to be developed, Pyrex has obviated it.)

2002-04-10  Chris Armstrong  <carmstro@twistedmatrix.com>

	* twisted/protocols/irc.py: Some fix-ups to IRCClient and
	DccFileReceive, from Joe Jordan (psy).

2002-04-10  Chris Armstrong  <carmstro@twistedmatrix.com>

	* twisted/reality: Gone. This is now in a completely separate plugin
	package.

2002-04-09  Itamar Shtull-Trauring  <itamarst@twistedmatrix.com>

	* win32 process support seems to *finally* be working correctly. Many
	thanks to Drew Whitehouse for help with testing and debugging.

2002-04-08  Itamar Shtull-Trauring  <itamarst@twistedmatrix.com>

	* coil refactored yet again, this time to use components and adapters.
	The design is now much cleaner.

2002-04-08  Glyph Lefkowitz  <glyph@zelda.twistedmatrix.com>

	* twisted/spread/jelly.py: Refactored jelly to provide (a) more
	sane, language-portable API for efficient extensibility and (b)
	final version of "wire" protocol.  This should be very close to
	the last wire-protocol-breaking change to PB before
	standardization happens.

2002-04-04  Glyph Lefkowitz  <glyph@twistedmatrix.com>

	* Removed __getattr__ backwards compatibility in PB

2002-04-03  Chris Armstrong  <carmstro@twistedmatrix.com>

	* twisted/python/usage.py, twisted/test/test_usage.py, bin/mktap, twisted/tap/*.py:
	Made the usage.Options interface better -- options are now stored in the
	'opts' dict. This is backwards compatible, and I added a deprecation warning.

2002-04-01  Chris Armstrong  <carmstro@twistedmatrix.com>

	* .: Releasing Twisted 0.16.0.

2002-03-29  Itamar Shtull-Trauring  <itamarst@twistedmatrix.com>

	* Added Qt event loop support, written by Sirtaj Singh Kang and
	Aleksandar Erkalovic.

2002-03-29  Itamar Shtull-Trauring  <itamarst@twistedmatrix.com>

	* Added a 'coil' command for configuring TAP files

2002-03-15  Itamar Shtull-Trauring  <itamarst@twistedmatrix.com>

	* XML-RPC published methods can now return Deferreds, and Twisted
	will Do The Right Thing.

2002-03-13  Itamar Shtull-Trauring  <itamarst@twistedmatrix.com>

	* Refactored coil, the configuration mechanism for Twisted.
	See twisted.coil and twisted.coil.plugins for examples of how
	to use the new interface. Chris Armstrong did some UI improvements
	for coil as well.

	* Checked in win32 Process support, and fixed win32 event loop.

2002-03-11  Glyph Lefkowitz  <glyph@janus.twistedmatrix.com>

	* More robust shutdown sequence for default mainloop (other
	mainloops should follow suit, but they didn't implement shutdown
	callbacks properly before anyway...).  This allows for shutdown
	callbacks to continue using the main loop.

2002-03-09  Itamar Shtull-Trauring  <itamarst@twistedmatrix.com>

	* Automatic log rotation for twistd. In addition, sending SIGUSR1
	to twistd will rotate the log.

2002-03-07  Chris Armstrong  <carmstro@twistedmatrix.com>

	* .: Releasing Twisted 0.15.5.

2002-03-06  Glyph Lefkowitz  <glyph@zelda.twistedmatrix.com>

	* twisted/web/html.py: Got rid of html.Interface. This was a really
	old, really deprecated API.

2002-03-06  Chris Armstrong  <carmstro@twistedmatrix.com>

	* twisted/web/widgets.py: Deprecated usage of Gadget.addFile(path)
	and replaced it with Gadget.putPath(path, pathname). This is
	a lot more flexible.

2002-03-05  Itamar Shtull-Trauring  <itamarst@twistedmatrix.com>

	* twisted/internet/win32.py: New win32 event loop, written by
	Andrew Bennetts.

	* twisted/tap/*: Changed the interface for creating tap modules - use
	a method called updateApplication instead of getPorts. this
	is a much more generic and useful mechanism.

	* twisted/internet/task.py: Fixed a bug where the schedular wasn't
	installed in some cases.

2002-03-04  Moshe Zadka  <moshez@twistedmatrix.com>

	* twisted/web/server.py: authorizer.Unauthorized->util.Unauthorized
	(leftovers from removing .passport references.)

	* twisted/names/dns.py: Added support for TTL.

2002-03-02  Chris Armstrong  <carmstro@twistedmatrix.com>

	* .: Releasing Twisted 0.15.4.

2002-03-02  Paul Swartz  <z3p@twistedmatrix.com>

	* twisted/words/ircservice.py: Send End-Of-MOTD message --
	some clients rely on this for automatic joining of channels
	and whatnot.

2002-03-02  Moshe Zadka  <moshez@twistedmatrix.com>

	* twisted/names/dns.py: Fixed bugs in DNS client

2002-03-01  Moshe Zadka  <moshez@twistedmatrix.com>

	* twisted/protocols/dns.py: Can now correctly serialize answers

	* twisted/names/dns.py: Can now do simple serving of domains

	* twisted/internet/stupid.py: Removed spurious debugging print

2002-02-28  Chris Armstrong  <carmstro@twistedmatrix.com>

	* .: Releasing 0.15.3.

2002-02-27  Itamar Shtull-Trauring  <itamarst@twistedmatrix.com>

	* twisted/mail/*, twisted/plugins.tml: The Mail server is now
	COILable.

	* bin/twistd: security fix: use a secure umask (077, rather than 0)
	for twistd.pid.

2002-02-26  Allen Short  <washort@twistedmatrix.com>

	* twisted/eco/eco.py, twisted/eco/sexpy.py: ECO now supports
	backquoting and macros.

2002-02-26  Itamar Shtull-Trauring  <itamarst@twistedmatrix.com>

	* twisted/protocols/ftp.py, twisted/plugins.tml: Made the FTP
	server COILable!

2002-02-26  Benjamin Bruheim  <phed@twistedmatrix.com>

	* twisted/web/distrib.py: Fixed a win32-compatibility bug.

2002-02-24  Itamar Shtull-Trauring  <itamarst@twistedmatrix.com>

	* twisted/protocols/socks.py: Made SOCKSv4 coilable, and fixed a
	bug so it'd work with Mozilla.

2002-02-24  Chris Armstrong  <carmstro@twistedmatrix.com>

	* .: Releasing Twisted 0.15.2.

2002-02-24  Itamar Shtull-Trauring  <itamarst@twistedmatrix.com>

	* setup.py: Added plugins.tml and instancemessenger.glade installs
	so mktap and t-im work in a 'setup.py install' install.

	* debian/rules: Install plugins.tml so mktap works in debian installs.

	* doc/man/mktap.1, twistd.1: Updated the man pages to be more accurate.

2002-02-24  Chris Armstrong  <carmstro@twistedmatrix.com>

	* bin/mktap: Better error reporting when we don't find
	the plugins files.

	* bin/twistd: Print out the *real* usage description rather than
	barfing when we get bad command line arguments.

2002-02-24  Moshe Zadka  <moshez@twistedmatrix.com>

	* debian/rules: Install the instancemessenger.glade file, so IM
	will work in debian installs.

2002-02-24  Paul Swartz  <z3p@twistedmatrix.com>

	* twisted/protocols/oscar.py, socks.py, toc.py: Fixed a security
	hole in TOC where clients could call any method on the server.

2002-02-23  Itamar Shtull-Trauring  <itamarst@twistedmatrix.com>

	* twisted/tap/coil.py: There is now a tap-creator for COIL.

	* twisted/internet/stupidproxy.py: Now with COILability!

2002-02-23  Glyph Lefkowitz  <glyph@zelda.twistedmatrix.com>

	* bin/mktap: mktap now uses Plugins instead of searching through
	twisted.tap. Yay for unified configuration systems!


2002-02-22  Chris Armstrong  <carmstro@twistedmatrix.com>

	* twisted/im, twisted/words: t-im can now do topic setting (words
	only), fixed the Group Metadata-setting interface in the service.

2002-02-22  Glyph Lefkowitz  <glyph@zelda.twistedmatrix.com>

	* twisted/manhole: COIL can now load Plugins.

2002-02-21  Glyph Lefkowitz  <glyph@zelda.twistedmatrix.com>

	* twisted.spread.pb: Changed remote method invocations to be
	called through .callRemote rather than implicitly by getattr, and
	added LocalAsRemote utility class for emulating remote behavior.

2002-02-21  Itamar Shtull-Trauring  <itamarst@twistedmatrix.com>

	* twisted.protocols.ftp: Fixed a lot of serious bugs.

2002-02-20  Itamar Shtull-Trauring  <itamarst@twistedmatrix.com>

	* twisted.protocols.telnet: the python shell now supports
	multi-line commands and can be configured using coil.

2002-02-13  Itamar Shtull-Trauring  <itamarst@twistedmatrix.com>

	* twisted.lumberjack: a log rotation and viewing service.
	Currently only log rotation is supported.

2002-02-12  Kevin Turner  <acapnotic@twistedmatrix.com>

	* twisted/words/ircservice.py (IRCChatter.irc_AWAY): Fix bug
	where you can never come back from being away (at least using
	epic4).  Closes: #%d

2002-02-11  Chris Armstrong  <carmstro@twistedmatrix.com>

	* twisted/web/widgets.py: Changed Gadget.page to Gadget.pageFactory
	for clarity (this is backwards-compatible).

2002-02-10  Itamar Shtull-Trauring  <itamarst@twistedmatrix.com>

	* twisted/spread/jelly.py:
	* twisted/spread/banana.py:
	* twisted/spread/pb.py: fixed bugs found by pychecker, got rid
	of __ping__ method support, and added 'local_' methods to
	RemoteReference

	* twisted/persisted/styles.py: pychecker bug fixes

2002-02-09  Itamar Shtull-Trauring  <itamarst@twistedmatrix.com>

	* bin/eco: Created a command-line interpreter for ECO.

	* doc/man/eco.1: man page for bin/eco

2002-02-09  Chris Armstrong  <carmstro@twistedmatrix.com>

	* twisted/eco/eco.py: Reverted evaluator state back to functional-ness
	:) And added functions (anonymous and global), and broke various
	interfaces

2002-02-09  Allen Short  <washort@twistedmatrix.com>

	* twisted/eco/eco.py: Refactored evaluator into a class, improved
	python-function argument signatures, and added and/or/not functions.

2002-02-08  Kevin Turner  <acapnotic@twistedmatrix.com>

	* twisted/words/service.py, ircservice.py: Fixed annoying PING
	bug, and added /topic support.

2002-02-08  Glyph Lefkowitz  <glyph@twistedmatrix.com>

	* twisted/eco: Initial prototype of ECO, the Elegant C Overlay
	macro engine.

2002-02-02  Paul Swartz <z3p@twistedmatrix.com>

	* twisted/im/ircsupport.py:  Added support for the IRC protocol
	to IM.

2002-02-02  Chris Armstrong <carmstro@twistedmatrix.com>

	* twisted/python/deferred.py: added Deferred.addErrback, so now
	it's easy to attach errbacks to deferreds when you don't care
	about plain results.

	* twisted/im/chat.py, twisted/im/pbsupport.py: added support for
	displaying topics.

2002-02-02  Paul Swartz <z3p@twistedmatrix.com>

	* SOCKSv4 support: there is now a protocols.socks, which contains
	support for SOCKSv4, a TCP proxying protocol.  mktap also has
	support for the new protocol.

2002-02-02  Kevin Turner  <acapnotic@twistedmatrix.com>

	* twisted/words/ircservice.py (IRCChatter.receiveDirectMessage),
	(IRCChatter.receiveGroupMessage),
	(IRCChatter.irc_PRIVMSG): Added CTCP ACTION <-> emote translation

2002-02-01  Paul Swartz <z3p@twistedmatrix.com>

	* twisted/im/tocsupport.py: Added support for most of the TOC
	protocol to IM.


2002-02-01  Chris Armstrong  <carmstro@twistedmatrix.com>

	* twisted/im/*.py: added metadata/emote support to IM. "/me foo"
	now triggers a backwards-compatible emote.


2002-01-30  Itamar Shtull-Trauring  <itamarst@twistedmatrix.com>

	* twisted/internet/tcp.py: Fixed the bug where startFactory() would
	get called twice.

2002-01-30  Chris Armstrong  <carmstro@twistedmatrix.com>

	* twisted/im: a new client for twisted.words (and eventually
	much more) based on GTK+ and Glade. This is mainly glyph's
	code, but I organized it for him to check in.

	* twisted/words/service.py: metadata support for words messages
	(only {'style': 'emote'} is standardized as of yet)

2002-01-29  Itamar Shtull-Trauring <itamarst@twistedmatrix.com>

	* Added hook to tcp.Port and ssl.Port for limiting acceptable
	  connections - approveConnection(socket, addr).

2002-01-27  Chris Armstrong  <carmstro@twistedmatrix.com>

	* twisted/words/ircservice.py: You can now change the topic
	of a channel with '/msg channelName topic <topic>' - note that
	'channelName' does *not* include the '#'.

2002-01-23  Glyph Lefkowitz  <glyph@zelda.twistedmatrix.com>

	* Incompatible change to PB: all remote methods now return
	Deferreds.  This doesn't break code in as many places as possible,
	but the connection methods now work differently and have different
	signatures.

	* Incompatible change to Banana: Banana now really supports floats
	and long integers.  This involved removing some nasty hackery that
	was previously part of the protocol spec, so you'll need to
	upgrade.

	* Added a feature to Jelly: Jelly now supports unicode strings.

	* Improved Twisted.Forums considerably: still needs work, but it's
	growing into an example of what you can do with a Twisted.Web
	application.

	* Added Twisted.Web.Webpassport -- generic mechanism for web-based
	login to arbitrary services.  This in conjunction with some code
	in Forum that uses it.

	* Incompatible change in Enterprise: all query methods now return
	Deferreds, as well as take arguments in an order which makes it
	possible to pass arbitrary argument lists for using the database's
	formatting characters rather than python's.

2002-01-15  Glyph Lefkowitz  <glyph@zelda.twistedmatrix.com>

	* twisted/internet/passport.py: (and friends) Retrieval of
	perspectives is now asynchronous, hooray (this took way too long)!
	Perspectives may now be stored in external data sources.  Lurching
	slowly towards a stable API for the Passport system, along with
	Sean's recent commits of tools to manipulate it.

2002-01-14  Kevin Turner  <acapnotic@twistedmatrix.com>

	* twisted/python/explorer.py: reimplementated.  So it's better.
	And yes, I broke the API.

	* twisted/manhole/ui/spelunk_gnome.py: Less duplication of visages,
	and they're draggable now too.

2002-01-13  Itamar Shtull-Trauring  <itamarst@twistedmatrix.com>

	* Changed twisted.enterprise.adabi so operations can accept lists
	  of arguments. This allows us to use the database adaptor's native
	  SQL quoting ability instead of either doing it ourselves, or the
	  *current* way twisted does it (not doing it at all, AFAICT!).

	  cursor.execute("INSERT INTO foo VALUES (%s, %d), "it's magic", 12)

	  Problem is that different adaptors may have different codes for
	  quoting.

	* First go at database for twisted.bugs. I hate RDBMS. I hate web.

--- 0.13.0 Release ---

# Local Variables:
# add-log-time-format: add-log-iso8601-time-string
# End:
